/*
 * Header file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */
#ifndef __GUIFUNCTIONS__ 
  #define __GUIFUNCTIONS__
  
  #include "../pguiman.h"

  gint zanoreni;

  // working with database profiles
  gboolean
  gui_connect_db(T_Server * server, T_Profile * profile);

  gboolean
  gui_disconnect_all_dbs(void);

  gboolean
  gui_disconnect_db(T_Server * server, T_Profile * profile);

  gboolean
  gui_remove_profile(T_Server * server, T_Profile * profile);

  void
  gui_refresh(T_Server * server, T_Profile * profile);

  void
  free_profile(T_Profile * profile);

  // function for finding widget
  GtkWidget*
  get_widget_child_by_name(GtkWidget *widget, const gchar *widget_name);

  // properties panel close callback
  gboolean
  on_tab_close_clicked(GtkButton  *button, gpointer         user_data);
                     
  // show dependencies
  void
  show_dependencies(GtkTreeView * dep_treeview, GtkTreeView * ref_treeview,T_Dependencies *dep_on,	T_Dependencies *ref_by);

  void
  create_dependencies_tree_view (GtkTreeView * view, gchar * title);

  GtkTreeIter
  add_depend(GtkTreeStore * store, GtkTreeIter * iter, GdkPixbuf *icon, gchar * object, gchar * type);

                 
#endif
