/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */
 
#include "properties_widget.h"
#include "GUI_functions.h"
#include "main_window.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* Properties list	                                                                                                               */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

gboolean
focus_in_event
(GtkWidget *widget, GdkEventFocus *event, gpointer   user_data){
	GdkColor color;
  color.red = 250*257; //6B
  color.green = 210*257; // 9E
  color.blue = 210*257;  // CE
  
  gtk_widget_modify_bg (GTK_WIDGET(user_data), GTK_STATE_NORMAL, &color);
	
	return FALSE;
}

gboolean
focus_out_event
(GtkWidget *widget, GdkEventFocus *event, gpointer   user_data){
	GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
  
  gtk_widget_modify_bg (GTK_WIDGET(user_data), GTK_STATE_NORMAL, &color);
	
	return FALSE;
}

gboolean
focus_event
(GtkWidget *widget, GdkEventFocus *event, gpointer   user_data){

	GtkWidget * win = ((T_Col_select_window *)user_data)->window;
	if(!gtk_window_is_active(GTK_WINDOW(win))) gtk_widget_hide(win);
	return FALSE;
}
                                                   
void
add_header_proper(GtkBox * column1, GtkBox * column2, gchar * label, gchar * image){
	GdkColor color;
  color.red = 236*257; //6B
  color.green = 232*257; // 9E
  color.blue = 226*257;  // CE
 	GtkWidget * header_label_bg;
 	GtkWidget * hbox4;
 	GtkWidget * header_image;
 	GtkWidget * header_label;
 	GtkWidget * header_text_bg;
 	GtkWidget * header_text;
 	
  header_label_bg = gtk_event_box_new ();
  gtk_widget_show (header_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), header_label_bg, FALSE, FALSE, 0);
	gtk_widget_modify_bg (header_label_bg, GTK_STATE_NORMAL, &color);
	
  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (header_label_bg), hbox4);

  header_image = create_pixmap (image);
  gtk_widget_show (header_image);
  gtk_box_pack_start (GTK_BOX (hbox4), header_image, FALSE, TRUE, 5);
	
	gchar * text = bold_text(label, "#808080");
  header_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (header_label);
  gtk_box_pack_start (GTK_BOX (hbox4), header_label, FALSE, FALSE, 3);
  gtk_widget_set_size_request (header_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (header_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (header_label), 0, 0.5);
  
  
	header_text_bg = gtk_event_box_new ();
  gtk_widget_show (header_text_bg);
  gtk_box_pack_start (GTK_BOX (column2), header_text_bg, FALSE, TRUE, 0);
	gtk_widget_modify_bg (header_text_bg, GTK_STATE_NORMAL, &color);
	
  header_text = gtk_label_new ("");
  gtk_widget_show (header_text);
  gtk_container_add (GTK_CONTAINER (header_text_bg), header_text);
  gtk_widget_set_size_request (header_text, -1, 20);
  
}

void
add_noneditable_property(GtkBox * column1, GtkBox * column2, gchar * label, gchar * property){
	GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
 	GtkWidget * header_label_bg;
 	GtkWidget * header_label;
 	GtkWidget * header_text_bg;
 	GtkWidget * header_text;
 	
  header_label_bg = gtk_event_box_new ();
  gtk_widget_show (header_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), header_label_bg, FALSE, FALSE, 0);
	gtk_widget_modify_bg (header_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * text = normal_text_with_color(label, "#980F0F");
  header_label = gtk_label_new (text);
  free(text);
  
  gtk_widget_show (header_label);
  gtk_container_add (GTK_CONTAINER (header_label_bg), header_label);
  gtk_widget_set_size_request (header_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (header_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (header_label), 20, 0);
    
	header_text_bg = gtk_event_box_new ();
  gtk_widget_show (header_text_bg);
  gtk_box_pack_start (GTK_BOX (column2), header_text_bg, FALSE, TRUE, 0);
	gtk_widget_modify_bg (header_text_bg, GTK_STATE_NORMAL, &color);
	
	text = change_text_color(property, "#c8c8c8");
  header_text = gtk_label_new (text);
  free(text);
  gtk_widget_show (header_text);
  gtk_container_add (GTK_CONTAINER (header_text_bg), header_text);
  gtk_widget_set_size_request (header_text, -1, 20);
  gtk_misc_set_alignment (GTK_MISC (header_text), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (header_text), 2, 0);
  gtk_label_set_use_markup (GTK_LABEL (header_text), TRUE);
}

void
add_entry_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar * text){
  GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
  GtkWidget * entry_label_bg;  
  GtkWidget * entry_label;
  GtkWidget * entry_text;
  
  entry_label_bg = gtk_event_box_new ();
  gtk_widget_show (entry_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), entry_label_bg, FALSE, FALSE, 0);
	gtk_widget_modify_bg (entry_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * t = normal_text_with_color(label, "#980F0F");
  entry_label = gtk_label_new (t);
  free(t);
  
  gtk_widget_show (entry_label);
  gtk_container_add (GTK_CONTAINER (entry_label_bg), entry_label);
  gtk_widget_set_size_request (entry_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (entry_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (entry_label), 20, 0);
  
  entry_text = gtk_entry_new ();
  gtk_widget_show (entry_text);
  gtk_box_pack_start (GTK_BOX (column2), entry_text, FALSE, FALSE, 0);
  gtk_widget_set_size_request (entry_text, -1, 20);
  gtk_entry_set_has_frame (GTK_ENTRY (entry_text), FALSE);
  gtk_entry_set_invisible_char (GTK_ENTRY (entry_text), 8226);
  gtk_entry_set_text(GTK_ENTRY (entry_text), text);
  gtk_widget_set_name(entry_text, widget_name);
  
  g_signal_connect((gpointer)entry_text, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     entry_label_bg);
	g_signal_connect((gpointer)entry_text, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                     entry_label_bg);
   g_signal_connect ((gpointer) entry_text, "changed",
                    G_CALLBACK (on_entry_text_changed),
                    page);                                       
}


void
add_comment_entry_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar * text){
  GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
  GtkWidget * comment_entry_label_bg;  
  GtkWidget * comment_entry_label;
  GtkWidget * comment_entry_text;

  comment_entry_label_bg = gtk_event_box_new ();
  gtk_widget_show (comment_entry_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), comment_entry_label_bg, FALSE, TRUE, 0);
	gtk_widget_modify_bg (comment_entry_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * t = normal_text_with_color(label, "#980F0F");
  comment_entry_label = gtk_label_new (t);
  free(t);
  
  gtk_widget_show (comment_entry_label);
  gtk_container_add (GTK_CONTAINER (comment_entry_label_bg), comment_entry_label);
  gtk_widget_set_size_request (comment_entry_label, -1, 40);
  gtk_label_set_use_markup (GTK_LABEL (comment_entry_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (comment_entry_label), 20, 0);
  
  comment_entry_text = gtk_text_view_new ();
  gtk_widget_show (comment_entry_text);
  gtk_box_pack_start (GTK_BOX (column2), comment_entry_text, FALSE, FALSE, 0);
  gtk_widget_set_size_request (comment_entry_text, -1, 40);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (comment_entry_text), GTK_WRAP_WORD);
	gtk_text_view_set_left_margin (GTK_TEXT_VIEW (comment_entry_text), 2);
  gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (comment_entry_text)), text, -1);
  gtk_widget_set_name(comment_entry_text, widget_name);
  
  g_signal_connect((gpointer)comment_entry_text, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     comment_entry_label_bg);
	g_signal_connect((gpointer)comment_entry_text, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                     comment_entry_label_bg);
                     
	GtkTextBuffer * buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (comment_entry_text));

	g_signal_connect (G_OBJECT (buffer), "changed", 
                    G_CALLBACK (textview_changed), page);                   
}

void
add_spin_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gint number, gint min, gint max){
  GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
	GtkWidget *spin_label_bg;
  GtkWidget *spin_label;
  GtkObject *spin_adj;
  GtkWidget *spin;
    
  spin_label_bg = gtk_event_box_new ();
  gtk_widget_show (spin_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), spin_label_bg, FALSE, FALSE, 0);
	gtk_widget_modify_bg (spin_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * text = normal_text_with_color(label, "#980F0F");
  spin_label = gtk_label_new (text);
  free(text);
  
  gtk_widget_show (spin_label);
  gtk_container_add (GTK_CONTAINER (spin_label_bg), spin_label);
  gtk_widget_set_size_request (spin_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (spin_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (spin_label), 20, 0);
  
  spin_adj = gtk_adjustment_new (number, min, max, 1, 10, 10);
  spin = gtk_spin_button_new (GTK_ADJUSTMENT (spin_adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (column2), spin, FALSE, FALSE, 0);
  gtk_widget_set_size_request (spin, -1, 20);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin), TRUE);
  gtk_spin_button_set_snap_to_ticks (GTK_SPIN_BUTTON (spin), TRUE);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spin), TRUE);
  g_object_set (spin, "has_frame", FALSE, NULL);
  gtk_widget_set_name(spin, widget_name);
  
  g_signal_connect((gpointer)spin, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     spin_label_bg);
	g_signal_connect((gpointer)spin, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                     spin_label_bg);
	g_signal_connect ((gpointer) spin, "changed",
                    G_CALLBACK (on_spin_changed),
                    page);                     
}

void
add_combo_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar ** list, gint n_list, gint active){
  GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
	GtkWidget *combo_label_bg;
  GtkWidget *combo_label;
  GtkWidget *combo; 
  
  combo_label_bg = gtk_event_box_new ();
  gtk_widget_show (combo_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), combo_label_bg, FALSE, TRUE, 0);
	gtk_widget_modify_bg (combo_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * text = normal_text_with_color(label, "#980F0F");
  combo_label = gtk_label_new (text);
  free(text);
  
  gtk_widget_show (combo_label);
  gtk_container_add (GTK_CONTAINER (combo_label_bg), combo_label);
  gtk_widget_set_size_request (combo_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (combo_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (combo_label), 20, 0);
  
  combo = gtk_combo_box_entry_new_text ();
  gtk_widget_set_name(combo, widget_name);
  gtk_widget_show (combo);
  gtk_box_pack_start (GTK_BOX (column2), combo, FALSE, TRUE, 0);
  gtk_widget_set_size_request (combo, -1, 20);
    
  for(int i = 0; i < n_list; i++){
  	gtk_combo_box_append_text (GTK_COMBO_BOX (combo), list[i]);
  }
  gtk_combo_box_set_active(GTK_COMBO_BOX (combo), active);
  
  g_object_set (combo, "has_frame", FALSE, NULL);  
  
  gtk_entry_set_editable(GTK_ENTRY(GTK_BIN(combo)->child), FALSE);
  
  g_signal_connect((gpointer)GTK_BIN(combo)->child, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     combo_label_bg);
	g_signal_connect((gpointer)GTK_BIN(combo)->child, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                     combo_label_bg);
	g_signal_connect ((gpointer) combo, "changed",
                    G_CALLBACK (on_combo_changed),
                    page);                     
}

void
add_toggle_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gboolean property, gboolean editable){
  GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
	GtkWidget *toggle_label_bg;
  GtkWidget *toggle_label;
  GtkWidget *toggle; 
  GtkWidget *hbox5; 
  GtkWidget *eventbox10; 
  GtkWidget *eventbox11; 
  GtkWidget *eventbox12; 
  
  toggle_label_bg = gtk_event_box_new ();
  gtk_widget_show (toggle_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), toggle_label_bg, FALSE, TRUE, 0);
	gtk_widget_modify_bg (toggle_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * text = normal_text_with_color(label, "#980F0F");
	toggle_label = gtk_label_new (text);
  free(text);
  
  gtk_widget_show (toggle_label);
  gtk_container_add (GTK_CONTAINER (toggle_label_bg), toggle_label);
  gtk_widget_set_size_request (toggle_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (toggle_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (toggle_label), 20, 0);
  
  eventbox10 = gtk_event_box_new ();
  gtk_widget_show (eventbox10);
  gtk_box_pack_start (GTK_BOX (column2), eventbox10, FALSE, FALSE, 0);
	gtk_widget_modify_bg (eventbox10, GTK_STATE_NORMAL, &color);
	
  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (eventbox10), hbox5);

  eventbox11 = gtk_event_box_new ();
  gtk_widget_show (eventbox11);
  gtk_box_pack_start (GTK_BOX (hbox5), eventbox11, TRUE, TRUE, 0);
	gtk_widget_modify_bg (eventbox11, GTK_STATE_NORMAL, &color);
	
  toggle = gtk_check_button_new();
  gtk_widget_set_name(toggle, widget_name);
  gtk_widget_show (toggle);
  gtk_box_pack_start (GTK_BOX (hbox5), toggle, FALSE, FALSE, 0);
  gtk_widget_set_size_request (toggle, -1, 20);
  gtk_button_set_relief (GTK_BUTTON (toggle), GTK_RELIEF_NONE);
  
  gtk_widget_set_name(toggle, widget_name);


  eventbox12 = gtk_event_box_new ();
  gtk_widget_show (eventbox12);
  gtk_box_pack_start (GTK_BOX (hbox5), eventbox12, TRUE, TRUE, 0);
  gtk_widget_modify_bg (eventbox12, GTK_STATE_NORMAL, &color);
  
  if(property) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle), TRUE);
  else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle), FALSE);
  
  if(!editable) gtk_widget_set_sensitive(toggle, FALSE);
  
  g_signal_connect((gpointer)toggle, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     toggle_label_bg);
	g_signal_connect((gpointer)toggle, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                     toggle_label_bg);
	g_signal_connect ((gpointer) toggle, "toggled",
                    G_CALLBACK (on_toggle_toggled),
                    page);                     
}

void
add_column_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar * text, T_Profile * profile, gint i_schema, gint i_table, T_Column ** columns, gint n_cols){
  GdkColor color;
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
	GtkWidget *column_select_label_bg;
  GtkWidget *column_select_label;
  GtkWidget *column_select_text;
  GtkWidget *column_select_drop_down;  
  GtkWidget *hbox6;
  GtkWidget *image21;
  GtkWidget *hbox7;
  GtkWidget *alignment5;   
  // column select window variables
   GtkWidget *window3;
  GtkWidget *vbox4;
  GtkWidget *hbox9;
  GtkWidget *scrolledwindow3;
  GtkWidget *awailable_columns;
  GtkWidget *vbox5;
  GtkWidget *eventbox14;
  GtkWidget *select_all;
  GtkWidget *alignment7;
  GtkWidget *hbox10;
  GtkWidget *image22;
  GtkWidget *select;
  GtkWidget *alignment8;
  GtkWidget *hbox11;
  GtkWidget *image23;
  GtkWidget *remove;
  GtkWidget *alignment9;
  GtkWidget *hbox12;
  GtkWidget *image24;
  GtkWidget *remove_all;
  GtkWidget *alignment10;
  GtkWidget *hbox13;
  GtkWidget *image25;
  GtkWidget *eventbox15;
  GtkWidget *scrolledwindow4;
  GtkWidget *selected_columns;
  GtkWidget *separator;
  GtkWidget *close_bg;
  GtkWidget *hbuttonbox1;
  GtkWidget *close;
  GtkWidget *alignment6;
  GtkWidget *hbox8;
  GtkWidget *label19;
  
  column_select_label_bg = gtk_event_box_new ();
  gtk_widget_show (column_select_label_bg);
  gtk_box_pack_start (GTK_BOX (column1), column_select_label_bg, FALSE, TRUE, 0);
	gtk_widget_modify_bg (column_select_label_bg, GTK_STATE_NORMAL, &color);
	
	gchar * t = normal_text_with_color(label, "#980F0F");
  column_select_label = gtk_label_new (t);
  free(t);
  
  gtk_widget_show (column_select_label);
  gtk_container_add (GTK_CONTAINER (column_select_label_bg), column_select_label);
  gtk_widget_set_size_request (column_select_label, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (column_select_label), TRUE);
  gtk_misc_set_padding (GTK_MISC (column_select_label), 20, 0);
   
  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (column2), hbox6, FALSE, TRUE, 0);

  column_select_text = gtk_entry_new ();
  gtk_widget_set_name(column_select_text, widget_name);
  gtk_widget_show (column_select_text);
  gtk_box_pack_start (GTK_BOX (hbox6), column_select_text, TRUE, TRUE, 0);
  gtk_widget_set_size_request (column_select_text, -1, 20);
  gtk_entry_set_has_frame (GTK_ENTRY (column_select_text), FALSE);
  gtk_entry_set_invisible_char (GTK_ENTRY (column_select_text), 8226);
	gtk_entry_set_editable(GTK_ENTRY (column_select_text), FALSE);
	gtk_entry_set_text(GTK_ENTRY (column_select_text), text);
	
  column_select_drop_down = gtk_button_new ();
  gtk_widget_show (column_select_drop_down);
  gtk_box_pack_start (GTK_BOX (hbox6), column_select_drop_down, FALSE, TRUE, 0);
  gtk_widget_set_size_request (column_select_drop_down, 28, 20);
  
  alignment5 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment5);
  gtk_container_add (GTK_CONTAINER (column_select_drop_down), alignment5);

  hbox7 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (alignment5), hbox7);

  image21 = create_pixmap (PIXMAP_DIRECTORY "/Drop_down.png");
  gtk_widget_show (image21);
  gtk_box_pack_start (GTK_BOX (hbox7), image21, FALSE, FALSE, 0);
  
  // create column select window
  
  window3 = gtk_window_new (GTK_WINDOW_POPUP);
  gtk_widget_set_name(window3, widget_name);
  gtk_widget_set_size_request (window3, 450, 250);
  gtk_window_set_modal (GTK_WINDOW (window3), TRUE);
  gtk_window_set_resizable (GTK_WINDOW (window3), TRUE);
  gtk_window_set_destroy_with_parent (GTK_WINDOW (window3), TRUE);
  gtk_window_set_decorated (GTK_WINDOW (window3), FALSE);
  gtk_window_set_skip_taskbar_hint (GTK_WINDOW (window3), TRUE);
  gtk_window_set_skip_pager_hint (GTK_WINDOW (window3), TRUE);
	color.red = 152*257; //6B
  color.green = 15*257; // 9E
  color.blue = 15*257;  // CE
	gtk_widget_modify_bg (window3, GTK_STATE_NORMAL, &color);
	
	
	GtkWidget * column_select_window_frame = gtk_event_box_new ();
  gtk_widget_set_name (column_select_window_frame, "column_select_window_frame");
  gtk_widget_show (column_select_window_frame);
  gtk_container_add (GTK_CONTAINER (window3), column_select_window_frame);
  gtk_container_set_border_width (GTK_CONTAINER (column_select_window_frame), 1);
  
  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (column_select_window_frame), vbox4);

  hbox9 = gtk_hbox_new (FALSE, 6);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox9, TRUE, TRUE, 0);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (hbox9), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_SHADOW_IN);

  awailable_columns = gtk_tree_view_new ();
  gtk_widget_set_name(awailable_columns, "csw_available_cols");
  gtk_widget_show (awailable_columns);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), awailable_columns);
	create_column_select_property_list_view     (awailable_columns, "Available columns");
	
	GtkTreeModel * model = gtk_tree_view_get_model(GTK_TREE_VIEW(awailable_columns));
	GtkListStore * store = GTK_LIST_STORE(model);
	GtkTreeIter child;
	
	for(int i = 0; i < profile->database.schema[i_schema]->table[i_table]->n_columns; i++){
		gboolean show = TRUE;
		for(int j = 0; j < n_cols; j++){
			if(columns != NULL && profile->database.schema[i_schema]->table[i_table]->column[i] == columns[j]){
				show=FALSE;
			}
		}
		if(show){
			gchar * text1;
 			gtk_list_store_append(store, &child);
 	
 			text1 = normal_text_with_color(profile->database.schema[i_schema]->table[i_table]->column[i]->name, "#000000");
			gtk_list_store_set(store, &child, 0, (profile->database.schema[i_schema]->table[i_table]->column[i]->pkey) ? get_icon(PIXMAP_DIRECTORY "/FieldPK.png") : get_icon(PIXMAP_DIRECTORY "/Field.png"), 1, text1, -1);
			free(text1);
		}
	}

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox5, FALSE, TRUE, 0);

  eventbox14 = gtk_event_box_new ();
  gtk_widget_show (eventbox14);
  gtk_box_pack_start (GTK_BOX (vbox5), eventbox14, TRUE, TRUE, 0);
  gtk_widget_set_size_request (eventbox14, 26, -1);

  select_all = gtk_button_new ();
  gtk_widget_show (select_all);
  gtk_box_pack_start (GTK_BOX (vbox5), select_all, FALSE, FALSE, 5);
  gtk_widget_set_size_request (select_all, 30, 26);

  alignment7 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment7);
  gtk_container_add (GTK_CONTAINER (select_all), alignment7);

  hbox10 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (alignment7), hbox10);

  image22 = gtk_image_new_from_stock ("gtk-media-forward", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image22);
  gtk_box_pack_start (GTK_BOX (hbox10), image22, FALSE, FALSE, 0);

  select = gtk_button_new ();
  gtk_widget_show (select);
  gtk_box_pack_start (GTK_BOX (vbox5), select, FALSE, FALSE, 5);
  gtk_widget_set_size_request (select, 26, 26);

  alignment8 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment8);
  gtk_container_add (GTK_CONTAINER (select), alignment8);

  hbox11 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (alignment8), hbox11);

  image23 = gtk_image_new_from_stock ("gtk-go-forward", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image23);
  gtk_box_pack_start (GTK_BOX (hbox11), image23, FALSE, FALSE, 0);

  remove = gtk_button_new ();
  gtk_widget_show (remove);
  gtk_box_pack_start (GTK_BOX (vbox5), remove, FALSE, FALSE, 5);
  gtk_widget_set_size_request (remove, 26, 26);

  alignment9 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment9);
  gtk_container_add (GTK_CONTAINER (remove), alignment9);

  hbox12 = gtk_hbox_new (FALSE, 2);
  gtk_widget_set_name (hbox12, "hbox12");
  gtk_widget_show (hbox12);
  gtk_container_add (GTK_CONTAINER (alignment9), hbox12);

  image24 = gtk_image_new_from_stock ("gtk-go-back", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image24);
  gtk_box_pack_start (GTK_BOX (hbox12), image24, FALSE, FALSE, 0);

  remove_all = gtk_button_new ();
  gtk_widget_show (remove_all);
  gtk_box_pack_start (GTK_BOX (vbox5), remove_all, FALSE, FALSE, 5);
  gtk_widget_set_size_request (remove_all, 26, 26);

  alignment10 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment10);
  gtk_container_add (GTK_CONTAINER (remove_all), alignment10);

  hbox13 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox13);
  gtk_container_add (GTK_CONTAINER (alignment10), hbox13);

  image25 = gtk_image_new_from_stock ("gtk-media-rewind", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image25);
  gtk_box_pack_start (GTK_BOX (hbox13), image25, FALSE, FALSE, 0);

  eventbox15 = gtk_event_box_new ();
  gtk_widget_show (eventbox15);
  gtk_box_pack_start (GTK_BOX (vbox5), eventbox15, TRUE, TRUE, 0);
  gtk_widget_set_size_request (eventbox15, 26, -1);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (hbox9), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_SHADOW_IN);

  selected_columns = gtk_tree_view_new ();
  gtk_widget_set_name(selected_columns, "csw_selected_cols");
  gtk_widget_show (selected_columns);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), selected_columns);
	create_column_select_property_list_view (selected_columns, "Selected columns");
	
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(selected_columns));
	store = GTK_LIST_STORE(model);
	
	for(int i = 0; i < n_cols; i++){
		gchar * text1;
 		gtk_list_store_append(store, &child);
 		text1 = normal_text_with_color(columns[i]->name, "#000000");
		gtk_list_store_set(store, &child, 0, (columns[i]->pkey) ? get_icon(PIXMAP_DIRECTORY "/FieldPK.png") : get_icon(PIXMAP_DIRECTORY "/Field.png"), 1, text1, -1);
		free(text1);
	}
	
  separator = gtk_event_box_new ();
  gtk_widget_show (separator);
  gtk_box_pack_start (GTK_BOX (vbox4), separator, FALSE, TRUE, 2);
  gtk_widget_set_size_request (separator, -1, 1);
	color.red = 152*257; //6B
  color.green = 15*257; // 9E
  color.blue = 15*257;  // CE
	gtk_widget_modify_bg (separator, GTK_STATE_NORMAL, &color);
		
  close_bg = gtk_event_box_new ();
  gtk_widget_show (close_bg);
  gtk_box_pack_start (GTK_BOX (vbox4), close_bg, FALSE, FALSE, 0);
  color.red = 255*257; //6B
  color.green = 255*257; // 9E
  color.blue = 255*257;  // CE
	gtk_widget_modify_bg (close_bg, GTK_STATE_NORMAL, &color);
	
  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_container_add (GTK_CONTAINER (close_bg), hbuttonbox1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_START);

  close = gtk_button_new ();
  gtk_widget_show (close);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), close);
  gtk_widget_set_size_request (close, -1, 27);
  gtk_container_set_border_width (GTK_CONTAINER (close), 2);
  GTK_WIDGET_SET_FLAGS (close, GTK_CAN_DEFAULT);

  alignment6 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment6);
  gtk_container_add (GTK_CONTAINER (close), alignment6);

  hbox8 = gtk_hbox_new (FALSE, 2);
  gtk_widget_set_name (hbox8, "hbox8");
  gtk_widget_show (hbox8);
  gtk_container_add (GTK_CONTAINER (alignment6), hbox8);

  label19 = gtk_label_new ("<span font_desc='Tahoma 8.25'>Close window</span>");
  gtk_widget_show (label19);get_icon(PIXMAP_DIRECTORY "/Common.png"),
  gtk_box_pack_start (GTK_BOX (hbox8), label19, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label19), TRUE);
  
  T_Col_select_window * win;
   
  if((win = (T_Col_select_window*) malloc(sizeof(T_Col_select_window))) == NULL){
  	fprintf(stderr, "Memory allocation error.");
  	exit(1);
  }
  win->window = window3;
  win->entry = GTK_ENTRY(column_select_text);
  win->awailable_columns = awailable_columns;
  win->selected_columns = selected_columns;
  
  g_signal_connect((gpointer)close, "clicked",
                    G_CALLBACK (column_select_property_close),
                     win);
  g_signal_connect((gpointer)column_select_drop_down, "clicked",
                    G_CALLBACK (column_select_property_drop_down),
                     win);
	g_signal_connect((gpointer)select_all, "clicked",
                    G_CALLBACK (column_select_property_select_all),
                    win);
  g_signal_connect((gpointer)select, "clicked",
                    G_CALLBACK (column_select_property_select),
                    win);
	g_signal_connect((gpointer)remove, "clicked",
                    G_CALLBACK (column_select_property_remove),
                    win);
  g_signal_connect((gpointer)remove_all, "clicked",
                    G_CALLBACK (column_select_property_remove_all),
                    win);   
	g_signal_connect_after((gpointer)window3, "focus-out-event",
                    G_CALLBACK (focus_event),
                    win);
                      
  // connect focus signals
    g_signal_connect((gpointer)column_select_text, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     column_select_label_bg);
	g_signal_connect((gpointer)column_select_text, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                    column_select_label_bg);
	  g_signal_connect((gpointer)window3, "focus-in-event",
                    G_CALLBACK (focus_in_event),
                     column_select_label_bg);
	g_signal_connect((gpointer)window3, "focus-out-event",
                    G_CALLBACK (focus_out_event),
                    column_select_label_bg);                    
  
}

void
column_select_property_close(GtkButton * button, gpointer user_data){
	T_Col_select_window * csw_struct = ((T_Col_select_window *) user_data);
	
	GtkTreeIter iter;
	GtkTreeView * view = GTK_TREE_VIEW(csw_struct->selected_columns);
	GtkTreeModel * model = gtk_tree_view_get_model(view);
	gchar * value;
	gboolean next = FALSE;
	gchar * cols = append_string(NULL, "");
	
	if(gtk_tree_model_get_iter_first(model, &iter)){
			do{
				gtk_tree_model_get(model, &iter, 1, &value,-1);
				
				gchar * s = get_text_from_markup(value);
				cols = append_string(cols, s);
				free(value);
				free(s);	
				if(gtk_tree_model_iter_next(model,&iter)){
					cols = append_string(cols, ", ");
				 	next =TRUE;
				}
				else next = FALSE;
	 		}while(next);
	}
	
	gtk_entry_set_text(GTK_ENTRY(csw_struct->entry), cols);
	free(cols);
	gtk_widget_hide(csw_struct->window);
}

void
column_select_property_drop_down(GtkButton * button, gpointer user_data){
	T_Col_select_window * csw_struct = ((T_Col_select_window *) user_data);
	GtkWidget * window = csw_struct->window;
	GtkWidget * entry = GTK_WIDGET(csw_struct->entry);
	
	gint width, height;
	
	width = entry->allocation.width;
	height = entry->allocation.height;
																				
	GdkWindow *win;
  win = entry->window;
  gint wx, wy;
  gdk_window_get_origin (win, &wx, &wy);
 
 	gint X = wx;
 	gint Y = wy+height;

 	csw_struct->x = X;
 	csw_struct->y = Y;
 	
 	gtk_widget_set_size_request(window,  (width > 450) ? width : 450, 250);
 	gtk_window_move(GTK_WINDOW(window), X, Y);
 	gtk_widget_show(window);
	
}

void
column_select_property_select_all(GtkButton * button, gpointer user_data){
	T_Col_select_window * csw_struct = ((T_Col_select_window *) user_data);
	
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(csw_struct->awailable_columns);
	GtkTreeView * view2 = GTK_TREE_VIEW(csw_struct->selected_columns);
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;
	
	while(gtk_tree_model_get_iter_first(model1,&iter)){
		GdkPixbuf       *icon;
		
		gtk_tree_model_get(model1, &iter, 0, &icon, 1, &value,-1);
		
		GtkListStore   *store;
  	
		store= GTK_LIST_STORE(model2);
			
	 gtk_list_store_append(store, &new);
	 
    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		
		gtk_list_store_remove(GTK_LIST_STORE(model1), &iter);
	}
	
}

void
column_select_property_select(GtkButton * button, gpointer user_data){
	T_Col_select_window * csw_struct = ((T_Col_select_window *) user_data);
	
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(csw_struct->awailable_columns);
	GtkTreeView * view2 = GTK_TREE_VIEW(csw_struct->selected_columns);
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;	
	GdkPixbuf       *icon;
	
	if(gtk_tree_selection_get_selected(gtk_tree_view_get_selection(view1), &model1, &iter)){
		gtk_tree_model_get(model1, &iter, 0,&icon,1, &value,-1);
		
		GtkListStore   *store;
		
		store= GTK_LIST_STORE(model2);
        
		gtk_list_store_append(store, &new);

    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		gtk_list_store_remove(GTK_LIST_STORE(model1), &iter);
		gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view2), &new);
	}
}

void
column_select_property_remove(GtkButton * button, gpointer user_data){
	T_Col_select_window * csw_struct = ((T_Col_select_window *) user_data);
	
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(csw_struct->awailable_columns);
	GtkTreeView * view2 = GTK_TREE_VIEW(csw_struct->selected_columns);
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;	
	GdkPixbuf       *icon;
	
	if(gtk_tree_selection_get_selected(gtk_tree_view_get_selection(view2), &model2, &iter)){
		gtk_tree_model_get(model2, &iter, 0,&icon,1, &value,-1);
		
		GtkListStore   *store;
		
		store= GTK_LIST_STORE(model1);
        
		gtk_list_store_append(store, &new);

    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		gtk_list_store_remove(GTK_LIST_STORE(model2), &iter);
		gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view1), &new);
	}
}

void
column_select_property_remove_all(GtkButton * button, gpointer user_data){
	T_Col_select_window * csw_struct = ((T_Col_select_window *) user_data);
	
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(csw_struct->awailable_columns);
	GtkTreeView * view2 = GTK_TREE_VIEW(csw_struct->selected_columns);
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;
	
	while(gtk_tree_model_get_iter_first(model2,&iter)){
		GdkPixbuf       *icon;
		
		gtk_tree_model_get(model2, &iter, 0, &icon, 1, &value,-1);
		
		GtkListStore   *store;
  	
		store= GTK_LIST_STORE(model1);
			
	 gtk_list_store_append(store, &new);
	 
    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		
		gtk_list_store_remove(GTK_LIST_STORE(model2), &iter);
	}
		
}

void
create_column_select_property_list_view     (GtkWidget * view, gchar * title)
{
    GtkTreeModel      *model;
    GtkTreeViewColumn *col;
    GtkCellRenderer   *renderer;

    model = GTK_TREE_MODEL(gtk_list_store_new(NUM_COLS, GDK_TYPE_PIXBUF, G_TYPE_STRING));
    
    gtk_tree_view_set_model(GTK_TREE_VIEW(view), model);
		
    col = gtk_tree_view_column_new();
    gtk_tree_view_column_set_title(col, title);
     
    renderer = gtk_cell_renderer_pixbuf_new();
    gtk_tree_view_column_pack_start(col, renderer, FALSE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "pixbuf", COL_ICON,
                                        NULL);

    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_column_pack_start(col, renderer, TRUE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "markup", COL_TEXT,
                                        NULL);

    gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);
     
    gtk_widget_show_all(view);
}

// properties callbacks
void
textview_changed (GtkTextBuffer *textbuffer, gpointer user_data){
	T_Page * page;
	page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data));
	if(page != NULL){
	  page->modified = TRUE;
	  gchar * text = normal_text((page->modified)? "Modified": "");
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "statusbar_label2")), text);
		free(text);
		GtkWidget * wid = get_widget_child_by_name(page->page, "apply_changes");
		if(wid != NULL)	gtk_widget_show(wid);		
	}
}
                    
void
on_entry_text_changed (GtkEditable *editable, gpointer user_data){
	T_Page * page;
	page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data));
	if(page != NULL){
	  page->modified = TRUE;
	  gchar * text = normal_text((page->modified)? "Modified": "");
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "statusbar_label2")), text);
		free(text);
		GtkWidget * wid = get_widget_child_by_name(page->page, "apply_changes");
		if(wid != NULL)	gtk_widget_show(wid);		
	}
}

void
on_spin_changed (GtkEditable *editable, gpointer user_data){
	T_Page * page;
	page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data));
	if(page != NULL){
	  page->modified = TRUE;
	  gchar * text = normal_text((page->modified)? "Modified": "");
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "statusbar_label2")), text);
		free(text);
		GtkWidget * wid = get_widget_child_by_name(page->page, "apply_changes");
		if(wid != NULL)	gtk_widget_show(wid);
	}
}
                                        
void
on_combo_changed (GtkComboBox *combobox, gpointer user_data){
	T_Page * page;
	page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data));
	if(page != NULL){
	  page->modified = TRUE;
	  gchar * text = normal_text((page->modified)? "Modified": "");
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "statusbar_label2")), text);
		free(text);
		GtkWidget * wid = get_widget_child_by_name(GTK_WIDGET(user_data), "apply_changes");
		if(wid != NULL)	gtk_widget_show(wid);	
	}
}
                                        
void
on_toggle_toggled (GtkToggleButton *togglebutton, gpointer user_data){
	T_Page * page;
	page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data));
	if(page != NULL){
	  page->modified = TRUE;
	  gchar * text = normal_text((page->modified)? "Modified": "");
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "statusbar_label2")), text);
		free(text);
		GtkWidget * wid = get_widget_child_by_name(GTK_WIDGET(user_data), "apply_changes");
		if(wid != NULL)	gtk_widget_show(wid);
	}
}
// properties_widget.c
