/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */
 
#include "treeview_functions.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* Creating result data treeview                                                                                        */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
add_row_number_column(GtkTreeView * view, gint col_num){
	GtkTreeViewColumn *col;
  GtkCellRenderer   *renderer;
  
  col = gtk_tree_view_column_new();

  renderer = gtk_cell_renderer_text_new();
  gtk_tree_view_column_pack_start(col, renderer, TRUE);
  gtk_tree_view_column_set_attributes(col, renderer,
                                        "markup", col_num,
                                        NULL);
  GdkColor color1;
  color1.red = 236*257; //6B
  color1.green = 232*257; // 9E
  color1.blue = 226*257;  // CE
  GdkColor color2;
  color2.red = 128*257; //6B
  color2.green = 128*257; // 9E
  color2.blue = 128*257;  // CE
  g_object_set(renderer, "foreground-gdk", &color2, "foreground-set",  TRUE, "background-gdk", &color1, "background-set",TRUE, NULL);
                                            
  gtk_tree_view_append_column(view, col);
}

void
add_icon_column(GtkTreeView * view, gchar * title, gint col_num){
	GtkTreeViewColumn *col;
  GtkCellRenderer   *renderer;
  
  col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, title);
	
	gchar *text = normal_text(title);
  GtkWidget * col_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (col_label);
  gtk_label_set_use_markup (GTK_LABEL (col_label), TRUE);
	
	gtk_tree_view_column_set_widget(col, col_label);
  
  
  renderer = gtk_cell_renderer_pixbuf_new();
  gtk_tree_view_column_pack_start(col, renderer, FALSE);
  gtk_tree_view_column_set_attributes(col, renderer,
                                        "pixbuf", col_num,
                                        NULL);
                                        
  renderer = gtk_cell_renderer_text_new();
  gtk_tree_view_column_pack_start(col, renderer, TRUE);
  gtk_tree_view_column_set_attributes(col, renderer,
                                        "markup", col_num+1,
                                        NULL);
                                     
                                              
  gtk_tree_view_append_column(view, col);
}

void
add_text_column(GtkTreeView * view, gchar * title, gint col_num){
	GtkTreeViewColumn *col;
  GtkCellRenderer   *renderer;
  
  col = gtk_tree_view_column_new();
  gtk_tree_view_column_set_title(col, title);

	gchar *text = normal_text(title);
  GtkWidget * col_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (col_label);
  gtk_label_set_use_markup (GTK_LABEL (col_label), TRUE);

	gtk_tree_view_column_set_widget(col, col_label);

  renderer = gtk_cell_renderer_text_new();
  gtk_tree_view_column_pack_start(col, renderer, TRUE);
  gtk_tree_view_column_set_attributes(col, renderer,
                                        "markup", col_num,
                                        NULL);
                                            
  gtk_tree_view_append_column(view, col);
}

void
add_bool_column(GtkTreeView * view, gchar * title, gint col_num){
	GtkTreeViewColumn *col;
  GtkCellRenderer   *renderer;
  
  col = gtk_tree_view_column_new();
  gtk_tree_view_column_set_title(col, title);
  
	gchar *text = normal_text(title);
  GtkWidget * col_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (col_label);
  gtk_label_set_use_markup (GTK_LABEL (col_label), TRUE);

	gtk_tree_view_column_set_widget(col, col_label);  
  
  renderer = gtk_cell_renderer_toggle_new();
  gtk_tree_view_column_pack_start(col, renderer, TRUE);
                                 
  gtk_tree_view_append_column(view, col);
}

// treeview_functions.c
