/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "database.h"
#include "../database/create_db_objects.h"
#include "../database/edit_db_objects.h"
#include "../database/drop_db_objects.h"
#include "../database/get_db_objects.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"
#include "../GUI/treeview_functions.h"
#include "../GUI_wizards/db_wizard.h"
#include "../otree/show_otree.h"


/*
 * Creates properties panel
 */
void
create_db_info(GtkWidget * main_notebook ,T_Profile * profile, gchar * path)
{
	GtkWidget *tab_database;
  GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;
  
  GtkWidget *tab_db;
  GtkWidget *notebook5;
  GtkWidget *vpaned2;
  GtkWidget *vbox18;
  GtkWidget *tab_db_olabelbg;
  GtkWidget *hbox69;
  GtkWidget *tab_db_oimg;
  GtkWidget *tab_db_olabel;
  GtkWidget *notebook6;
  GtkWidget *scrolledwindow27;
  GtkWidget *treeview25;
  GtkWidget *label155;
  GtkWidget *scrolledwindow28;
  GtkWidget *treeview26;
  GtkWidget *label156;
  GtkWidget *scrolledwindow29;
  GtkWidget *treeview27;
  GtkWidget *label157;
  GtkWidget *vbox19;
  GtkWidget *tab_db_propertiesbg;
  GtkWidget *hbox68;
  GtkWidget *tab_db_pimg;
  GtkWidget *tab_db_properties;
  GtkWidget *scrolledwindow32;
  GtkWidget *label161;
  GtkWidget *scrolledwindow35;
  GtkWidget *treeview33;
  GtkWidget *label163;
  GtkWidget *scrolledwindow36;
  GtkWidget *textview2;
  GtkWidget *label164;
  
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();
  
  // menu
  tab_database = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_database);
  
  /*gtk_hpaned_new ();
  gtk_widget_show (tab_database);
  gtk_paned_set_position (GTK_PANED (tab_database), -1);
*/
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_database), menu, FALSE, TRUE, 0);
  //gtk_paned_pack1 (GTK_PANED (tab_database), menu, FALSE, TRUE);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Database</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * object_name = normal_text_with_color(profile->alias, "#000000");
  object = gtk_label_new (object_name);
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Server</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	if(depth >=1 ){
		parent_name = normal_text_with_color(o_tree.server[intpath[0]]->name, "#000000");
	}
	else{
		parent_name = normal_text_with_color("unknown", "#980F0F");
	}
  database = gtk_label_new (parent_name);
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);

  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_db.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new database</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);

  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_db.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop database</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  //gtk_widget_show (apply_changes);
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);
  
  // main window
  
  
  tab_db = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_db);
	//gtk_paned_pack2 (GTK_PANED (tab_database), tab_db, TRUE, TRUE);
	gtk_box_pack_start (GTK_BOX (tab_database), tab_db, TRUE, TRUE, 0);
	
  notebook5 = gtk_notebook_new ();
  
  
  gtk_widget_set_name(notebook5, "main_notebook");
  
  
  gtk_widget_show (notebook5);
  gtk_box_pack_start (GTK_BOX (tab_db), notebook5, TRUE, TRUE, 0);

  vpaned2 = gtk_vpaned_new ();
  gtk_widget_show (vpaned2);
  gtk_container_add (GTK_CONTAINER (notebook5), vpaned2);
  gtk_paned_set_position (GTK_PANED (vpaned2), -1);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name(vbox18, "vrsek");
  gtk_widget_show (vbox18);
  gtk_paned_pack1 (GTK_PANED (vpaned2), vbox18, TRUE, TRUE);

  tab_db_olabelbg = gtk_event_box_new ();
  gtk_widget_show (tab_db_olabelbg);
  gtk_box_pack_start (GTK_BOX (vbox18), tab_db_olabelbg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_db_olabelbg, -1, 21);

  hbox69 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox69);
  gtk_container_add (GTK_CONTAINER (tab_db_olabelbg), hbox69);

  tab_db_oimg = create_pixmap (PIXMAP_DIRECTORY "/Schemas.png");
  gtk_widget_show (tab_db_oimg);
  gtk_box_pack_start (GTK_BOX (hbox69), tab_db_oimg, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_db_oimg), 0.52, 0.5);

  tab_db_olabel = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>label</span>");
  gtk_widget_show (tab_db_olabel);
  gtk_box_pack_start (GTK_BOX (hbox69), tab_db_olabel, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_db_olabel), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_db_olabel), 0, 0.99);

  notebook6 = gtk_notebook_new ();
  gtk_widget_show (notebook6);
  gtk_box_pack_start (GTK_BOX (vbox18), notebook6, TRUE, TRUE, 0);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook6), GTK_POS_BOTTOM);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook6), TRUE);
	
	scrolledwindow27 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow27);
  gtk_container_add (GTK_CONTAINER (notebook6), scrolledwindow27);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow27), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow27), GTK_SHADOW_IN);

  treeview25 = gtk_tree_view_new ();
  gtk_widget_show (treeview25);
  gtk_container_add (GTK_CONTAINER (scrolledwindow27), treeview25);

  label155 = gtk_label_new ("<span font_desc='8'>Schemas</span>");
  gtk_widget_show (label155);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook6), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook6), 0), label155);
  gtk_label_set_use_markup (GTK_LABEL (label155), TRUE);

  scrolledwindow28 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow28);
  gtk_container_add (GTK_CONTAINER (notebook6), scrolledwindow28);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow28), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow28), GTK_SHADOW_IN);

  treeview26 = gtk_tree_view_new ();
  gtk_widget_show (treeview26);
  gtk_container_add (GTK_CONTAINER (scrolledwindow28), treeview26);

  label156 = gtk_label_new ("<span font_desc='8'>Languages</span>");
  gtk_widget_show (label156);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook6), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook6), 1), label156);
  gtk_label_set_use_markup (GTK_LABEL (label156), TRUE);

  scrolledwindow29 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow29);
  gtk_container_add (GTK_CONTAINER (notebook6), scrolledwindow29);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow29), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow29), GTK_SHADOW_IN);

  treeview27 = gtk_tree_view_new ();
  gtk_widget_show (treeview27);
  gtk_container_add (GTK_CONTAINER (scrolledwindow29), treeview27);

  label157 = gtk_label_new ("<span font_desc='8'>Casts</span>");
  gtk_widget_show (label157);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook6), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook6), 2), label157);
  gtk_label_set_use_markup (GTK_LABEL (label157), TRUE);
	


  vbox19 = gtk_vbox_new (FALSE, 0);
	gtk_widget_set_name(vbox19, "spodek");
  gtk_widget_show (vbox19);
  gtk_paned_pack2 (GTK_PANED (vpaned2), vbox19, FALSE, TRUE);

  tab_db_propertiesbg = gtk_event_box_new ();
  gtk_widget_show (tab_db_propertiesbg);
  gtk_box_pack_start (GTK_BOX (vbox19), tab_db_propertiesbg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_db_propertiesbg, -1, 21);

  hbox68 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox68);
  gtk_container_add (GTK_CONTAINER (tab_db_propertiesbg), hbox68);

  tab_db_pimg = create_pixmap (PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_db_pimg);
  gtk_box_pack_start (GTK_BOX (hbox68), tab_db_pimg, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_db_pimg), 0.52, 0.5);

  tab_db_properties = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_db_properties);
  gtk_box_pack_start (GTK_BOX (hbox68), tab_db_properties, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_db_properties), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_db_properties), 0, 0.99);

  scrolledwindow32 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow32);
  gtk_box_pack_start (GTK_BOX (vbox19), scrolledwindow32, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow32), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow32), GTK_SHADOW_NONE);
	
	GtkWidget * viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport1), GTK_SHADOW_NONE);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow32), viewport1);
  
  GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport1), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);

  label161 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label161);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook5), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook5), 0), label161);
  gtk_label_set_use_markup (GTK_LABEL (label161), TRUE);

  scrolledwindow35 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow35);
  gtk_container_add (GTK_CONTAINER (notebook5), scrolledwindow35);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow35), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow35), GTK_SHADOW_IN);

  treeview33 = gtk_tree_view_new ();
  gtk_widget_show (treeview33);
  gtk_container_add (GTK_CONTAINER (scrolledwindow35), treeview33);

  label163 = gtk_label_new ("<span font_desc='Italic 8'>Permissions</span>");
  gtk_widget_show (label163);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook5), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook5), 1), label163);
  gtk_label_set_use_markup (GTK_LABEL (label163), TRUE);

  scrolledwindow36 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow36);
  gtk_container_add (GTK_CONTAINER (notebook5), scrolledwindow36);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow36), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow36), GTK_SHADOW_IN);

  textview2 = gtk_text_view_new ();
  gtk_widget_show (textview2);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (textview2), 7);
  gtk_container_add (GTK_CONTAINER (scrolledwindow36), textview2);

	label164 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label164);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook5), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook5), 2), label164);
  gtk_label_set_use_markup (GTK_LABEL (label164), TRUE);
  
 
  // create page label
 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_label;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
 
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Database.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(profile->dbname, "#000000");
  tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Database Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
 
  image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);
  
	// Modify colors 
	GdkColor color;
	
	// menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);
  
  // main colors
  color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
	gtk_widget_modify_bg (tab_db_olabelbg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_db_propertiesbg, GTK_STATE_NORMAL, &color);
  
	color.red = 236*257;
  color.green = 232*257;
  color.blue = 226*257;  
  gtk_widget_modify_bg (properties_background, GTK_STATE_NORMAL, &color);
  
	// Show properties	
	gint height = 0;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name",  profile->dbname);
	height += 21;	
	T_Roles * roles = get_roles(profile, FALSE);
	if(roles != NULL){
	gint role_id=-1;
	for(int i = 0; i < roles->n_roles; i++){
		if(strcmp(roles->name[i], profile->database.owner) == 0){
			role_id = i;
			break;
		}
	}
	add_combo_property("property_owner", tab_database, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Owner", roles->name,  roles->n_roles, role_id);
	for(int i = 0; i < roles->n_roles; i++){
		free(roles->name[i]);
	}
	free(roles->name);
	free(roles);
	}
	height += 21;	
	add_comment_entry_property("property_comment", tab_database, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", profile->database.comment);
	height += 41;
	text = itoa_n(profile->database.OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Database",  PIXMAP_DIRECTORY "/Database.png");
	height += 21;
	add_spin_property("property_conn_limit", tab_database, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Connection Limit (-1 for no limits)",  profile->database.connection_limit, -1, 1000);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Encoding", profile->database.encoding);
	height += 21;
	add_toggle_property("property_is_template", tab_database, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Is Template",  profile->database.is_template, FALSE);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Tablespace", profile->database.tablespace);
	height += 21;
	text = itoa_n(profile->database.lastOID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Last System OID", text);
	free(text);
	height += 21;
	gtk_widget_set_size_request (scrolledwindow32, -1, height);	
	
	// show sub objects
	// schemas
	gint n = profile->database.n_schemas;
	
	GType sch_types[5];
	sch_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview25), 0);
	sch_types[1] = GDK_TYPE_PIXBUF;
	sch_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview25), "Name", 1);
	sch_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview25), "Owner", 3);
	sch_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview25),"Comment", 4);
	GtkTreeModel * model = GTK_TREE_MODEL(gtk_list_store_newv(5, sch_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(profile->database.schema[i]->name,"#980F0F");
		gchar * text2 = normal_text(profile->database.schema[i]->owner);
		gchar * text3 = normal_text(profile->database.schema[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Schema.png"), 2, text1, 3, text2, 4, text3, -1);
		free(t); free(text); free(text1); free(text2); free(text3);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview25)), model);
	
	// languages
	n = profile->database.n_languages;
	
	GType lang_types[7];
	lang_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview26), 0);
	lang_types[1] = GDK_TYPE_PIXBUF;
	lang_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview26), "Name", 1);
	lang_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview26), "Trusted", 3);
	lang_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview26),"Handler", 4);
	lang_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview26),"Validator", 5);
	lang_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview26),"Comment", 6);
	model = GTK_TREE_MODEL(gtk_list_store_newv(7, lang_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(profile->database.language[i]->name,"#980F0F");
		gchar * text2 = normal_text((profile->database.language[i]->trusted) ? "True" : "False");
		gchar * text3 = normal_text(profile->database.language[i]->handler_func);
		gchar * text4 = normal_text(profile->database.language[i]->validator_func);
		gchar * text5 = normal_text(profile->database.language[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Language.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview26)), model);
	
	// casts
	n = profile->database.n_casts;
	
	GType cast_types[8];
	cast_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview27), 0);
	cast_types[1] = GDK_TYPE_PIXBUF;
	cast_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview27), "Name", 1);
	cast_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview27), "Source Type", 3);
	cast_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview27),"Target Type", 4);
	cast_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview27),"Context", 5);
	cast_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview27),"Function", 6);
	cast_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview27),"Comment", 7);
	model = GTK_TREE_MODEL(gtk_list_store_newv(8, cast_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(profile->database.cast[i]->name,"#980F0F");
		gchar * text2 = normal_text(profile->database.cast[i]->source_type);
		gchar * text3 = normal_text(profile->database.cast[i]->target_type);
		gchar * text4 = normal_text(profile->database.cast[i]->context);
		gchar * text5 = normal_text(profile->database.cast[i]->function);
		gchar * text6 = normal_text(profile->database.cast[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Cast.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview27)), model);
	
	//init sql code textview
	gchar * sql = create_new_database_SQL_query(profile);
	init_text_view(textview2, FALSE, sql);
	free(sql);

	// connect signals
	g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_db_close_clicked),
                    tab_database);
                    
  g_signal_connect ((gpointer) create_object, "clicked",
                    G_CALLBACK (on_tab_db_create_new_database_clicked),
                    tab_database);
                    
	g_signal_connect ((gpointer) drop_object, "clicked",
                    G_CALLBACK (on_tab_db_drop_database_clicked),
                    tab_database);
                                        
  g_signal_connect ((gpointer) apply_changes, "clicked",
                    G_CALLBACK (on_tab_db_apply_changes_clicked),
                    tab_database);
                    
	g_signal_connect ((gpointer) notebook6, "switch-page",
                    G_CALLBACK (on_tab_db_objects_change_current_page),
                    hbox69);
                    
	// create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_database;
	page->path = path;
	page->object = profile;
	page->close_function = on_tab_db_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, profile->dbname);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook6), 2);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook6), 0);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}
}// create_db_info()

/*
 * Subobject notebook page changed
 */
void
on_tab_db_objects_change_current_page (GtkNotebook *nb, GtkNotebookPage *page, guint page_num, gpointer user_data)
{
	GList * children = gtk_container_get_children(GTK_CONTAINER(user_data));
	GtkWidget * label = NULL;
	GtkWidget * image = NULL;
	do{
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_LABEL) label = children->data;
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_IMAGE) image = children->data;
		children = children->next;
 	}while(children != NULL);
	
	switch(page_num){
	  case 0: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Schemas.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Schemas</span>");
									break;
		case 1: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Languages.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Languages</span>");
									break;
		case 2: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Casts.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Casts</span>");
									break;
		}
} // on_tab_db_objects_change_current_page ()

/*
 * Close properties panel
 */
gboolean
on_tab_db_close_clicked(GtkButton  *button, gpointer         user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		gtk_widget_destroy(GTK_WIDGET(user_data));
	}
	else{ // widget found
		if(page->modified){
			gchar * object_type = normal_text_with_color("Database", "#000000");
			
			GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
			gint depth = gtk_tree_path_get_depth(path);
			gint * intpath = gtk_tree_path_get_indices(path);
			gchar * object_name;
			if(depth >=3 ){
			  object_name = bold_text(o_tree.server[intpath[0]]->profile[intpath[2]]->alias, "#980F0F");
			}
			else{
				object_name = bold_text(" ", "#980F0F");
			}
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_type")), object_type);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_name")), object_name);
			free(object_type);
			free(object_name);
	
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "question_dialog")));
			if(res == GTK_RESPONSE_YES){ // Yes
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				
				on_tab_db_apply_changes_clicked(NULL, user_data);
				
				remove_page_from_list( &notebook, page);
			}
			else if(res == GTK_RESPONSE_NO){ // No
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				remove_page_from_list( &notebook, page);
			}
			else{ // Cancel
			  gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
			  return FALSE;
			}
		}
		else remove_page_from_list( &notebook, page);
	}
	
	
	return TRUE;
} // on_tab_db_close_clicked ()

/*
 * Apply changes
 */
void
on_tab_db_apply_changes_clicked(GtkButton *button, gpointer user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// new profile struct 
		T_Profile * new_profile, *old_profile;
		new_profile = (T_Profile *) malloc (sizeof(T_Profile));
		if(new_profile == NULL){
		   	fprintf(stderr, "Memory allocation error.");
	 			exit(0);
		}
		
		old_profile = (T_Profile *) page->object;
		
		// get properties
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_owner");
		if(wid == NULL) return;
		new_profile->database.owner = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
		
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_comment");
		if(wid == NULL) return;
		GtkTextBuffer * buffer;
		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
		GtkTextIter start, end;
  	gtk_text_buffer_get_start_iter(buffer, &start);
  	gtk_text_buffer_get_end_iter(buffer, &end);
		
		new_profile->database.comment = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
	
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_conn_limit");
		if(wid == NULL) return;
		
		new_profile->database.connection_limit = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(wid));

		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		
		gchar * sql = create_edit_database_SQL_query(old_profile, new_profile);
		
		if(sql != NULL){
			if(!execute_sql(sql, NULL, NULL, old_profile, TRUE, TRUE)){
				free(sql);
				return;
			}
			page->modified = FALSE;
			gui_refresh(server, profile);
			free(sql);
		}
		else{
			page->modified = FALSE;
			gui_refresh(server, profile);
		}
		
		free(new_profile->database.owner);
		free(new_profile->database.comment);
		free(new_profile);
		
	}
		
} // on_tab_db_apply_changes_clicked ()

/*
 * Create new object
 */
void
on_tab_db_create_new_database_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		run_c_db_wizard();
	}
} // on_tab_db_create_new_database_clicked ()

/*
 * Drop object
 */
void
on_tab_db_drop_database_clicked(GtkButton *button, gpointer user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
			
		}
		else{
			return;
		}
		
		// run dialog to confirm delete
		gchar * label = append_string(NULL, "Do you really want to drop database '");
		label = append_string(label, profile->dbname);	
		label = append_string(label, "'?");
		gchar * l = normal_text(label);
		free(label);
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml,"yes_no_dialog_label")), l);
		free(l);
		gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "yes_no_dialog")));
		if(res == GTK_RESPONSE_YES){
			gtk_widget_hide(glade_xml_get_widget(xml, "yes_no_dialog"));
		}
		else{
			gtk_widget_hide(glade_xml_get_widget(xml, "yes_no_dialog"));	
			return;
		}
		
		// create sql code
		gchar * sql = create_drop_database_SQL_query(profile);
		
		// execute sql
		if(sql != NULL){
			execute_sql(sql, NULL, NULL, profile, TRUE, TRUE);
			free(sql);
		}
	}
} // on_tab_db_drop_database_clicked ()
