/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "rule.h"
#include "../database/create_db_objects.h"
#include "../database/edit_db_objects.h"
#include "../database/drop_db_objects.h"
#include "../GUI_wizards/rule_wizard.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"

/*
 * Creates properties panel
 */
void
create_rule_info(GtkWidget * main_notebook ,T_Rule * rule, gchar * path)
{
	GtkWidget *tab_rule_main;	
	
	GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;

  GtkWidget *tab_rule;
  GtkWidget *tab_rule_vapend;
  GtkWidget *tab_rule_def;
  GtkWidget *tab_rule_def_label_bg;
  GtkWidget *hbox81;
  GtkWidget *tab_rule_def_label_img;
  GtkWidget *tab_rule_def_label;
  GtkWidget *scrolledwindow81;
  GtkWidget *tab_rule_def_text;
  GtkWidget *tab_rule_properties;
  GtkWidget *tab_rule_properties_label_bg;
  GtkWidget *hbox84;
  GtkWidget *tab_rule_properties_label_img;
  GtkWidget *tab_rule_properties_label;
  GtkWidget *scrolledwindow97;
  GtkWidget *label239;
  GtkWidget *tab_rule_depen_hpend;
  GtkWidget *scrolledwindow98;
  GtkWidget *tab_rule_depen_dep_on;
  GtkWidget *scrolledwindow99;
  GtkWidget *tab_rule_depen_ref_by;
  GtkWidget *label240;
  GtkWidget *scrolledwindow101;
  GtkWidget *tab_rule_sql_code;
  GtkWidget *label242;
  GtkWidget *tab_rule_tab_label;
  
  GtkTooltips *tooltips;
	tooltips = gtk_tooltips_new ();
  
  tab_rule_main = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_rule_main);
  // menu
   
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_rule_main), menu, FALSE, TRUE, 0);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Rule</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * obj = append_string(NULL, rule->parent_name);
	obj = append_string(obj, ".");
	obj = append_string(obj, rule->name);
	gchar * object_name = normal_text_with_color(obj, "#000000");
	free(obj);
  object = gtk_label_new (object_name);
  gtk_widget_set_name(object, "property_parent");  
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Schema</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	T_Profile * profile; 
	if(depth >=5 ){
		parent_name = normal_text_with_color(o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name, "#000000");
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
  database = gtk_label_new (parent_name);
  gtk_widget_set_name(database, "property_schema");
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);
	
  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_rule.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new rule</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);
	
  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_rule.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop rule</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);
  
  
  // main window
  tab_rule = gtk_notebook_new ();
  gtk_widget_show (tab_rule);
  gtk_box_pack_start (GTK_BOX (tab_rule_main), tab_rule, TRUE, TRUE, 0);

  tab_rule_vapend = gtk_vpaned_new ();
  gtk_widget_show (tab_rule_vapend);
  gtk_container_add (GTK_CONTAINER (tab_rule), tab_rule_vapend);
  gtk_paned_set_position (GTK_PANED (tab_rule_vapend), -1);
	
	tab_rule_def = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_rule_def);
  gtk_paned_pack1 (GTK_PANED (tab_rule_vapend), tab_rule_def, TRUE, TRUE);

  tab_rule_def_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_rule_def_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_rule_def), tab_rule_def_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_rule_def_label_bg, -1, 21);

  hbox81 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox81);
  gtk_container_add (GTK_CONTAINER (tab_rule_def_label_bg), hbox81);

  tab_rule_def_label_img = create_pixmap (PIXMAP_DIRECTORY "/SQL_editor.png");
  gtk_widget_show (tab_rule_def_label_img);
  gtk_box_pack_start (GTK_BOX (hbox81), tab_rule_def_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_rule_def_label_img), 0.52, 0.5);

  tab_rule_def_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Definition</span>");
  gtk_widget_show (tab_rule_def_label);
  gtk_box_pack_start (GTK_BOX (hbox81), tab_rule_def_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_rule_def_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_rule_def_label), 0, 0.99);

  scrolledwindow81 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow81);
  gtk_box_pack_start (GTK_BOX (tab_rule_def), scrolledwindow81, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow81), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow81), GTK_SHADOW_IN);

  tab_rule_def_text = gtk_text_view_new ();
  gtk_widget_set_name(tab_rule_def_text, "property_definition");
  gtk_widget_show (tab_rule_def_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow81), tab_rule_def_text);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_rule_def_text), 7);

  tab_rule_properties = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_rule_properties);
  gtk_paned_pack2 (GTK_PANED (tab_rule_vapend), tab_rule_properties, FALSE, TRUE);

  tab_rule_properties_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_rule_properties_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_rule_properties), tab_rule_properties_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_rule_properties_label_bg, -1, 21);

  hbox84 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox84);
  gtk_container_add (GTK_CONTAINER (tab_rule_properties_label_bg), hbox84);

  tab_rule_properties_label_img = create_pixmap (PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_rule_properties_label_img);
  gtk_box_pack_start (GTK_BOX (hbox84), tab_rule_properties_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_rule_properties_label_img), 0.52, 0.5);

  tab_rule_properties_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_rule_properties_label);
  gtk_box_pack_start (GTK_BOX (hbox84), tab_rule_properties_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_rule_properties_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_rule_properties_label), 0, 0.99);

  scrolledwindow97 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow97);
  gtk_box_pack_start (GTK_BOX (tab_rule_properties), scrolledwindow97, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow97), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow97), GTK_SHADOW_IN);

  GtkWidget * viewport = gtk_viewport_new (NULL, NULL);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport), GTK_SHADOW_NONE);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (scrolledwindow97), viewport);
	
	GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);

  label239 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label239);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_rule), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_rule), 0), label239);
  gtk_label_set_use_markup (GTK_LABEL (label239), TRUE);

  tab_rule_depen_hpend = gtk_hpaned_new ();
  gtk_widget_show (tab_rule_depen_hpend);
  gtk_container_add (GTK_CONTAINER (tab_rule), tab_rule_depen_hpend);
  gtk_paned_set_position (GTK_PANED (tab_rule_depen_hpend), -1);

  scrolledwindow98 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow98);
  gtk_paned_pack1 (GTK_PANED (tab_rule_depen_hpend), scrolledwindow98, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow98), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow98), GTK_SHADOW_IN);

  tab_rule_depen_dep_on = gtk_tree_view_new ();
  gtk_widget_show (tab_rule_depen_dep_on);
  gtk_container_add (GTK_CONTAINER (scrolledwindow98), tab_rule_depen_dep_on);

  scrolledwindow99 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow99);
  gtk_paned_pack2 (GTK_PANED (tab_rule_depen_hpend), scrolledwindow99, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow99), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow99), GTK_SHADOW_IN);

  tab_rule_depen_ref_by = gtk_tree_view_new ();
  gtk_widget_show (tab_rule_depen_ref_by);
  gtk_container_add (GTK_CONTAINER (scrolledwindow99), tab_rule_depen_ref_by);

  label240 = gtk_label_new ("<span font_desc='Italic 8'>Dependencies</span>");
  gtk_widget_show (label240);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_rule), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_rule), 1), label240);
  gtk_label_set_use_markup (GTK_LABEL (label240), TRUE);

  scrolledwindow101 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow101);
  gtk_container_add (GTK_CONTAINER (tab_rule), scrolledwindow101);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow101), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow101), GTK_SHADOW_IN);

  tab_rule_sql_code = gtk_text_view_new ();
  gtk_widget_show (tab_rule_sql_code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow101), tab_rule_sql_code);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_rule_sql_code), 7);

  label242 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label242);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_rule), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_rule), 2), label242);
  gtk_label_set_use_markup (GTK_LABEL (label242), TRUE);

   GdkColor color;
	// menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);

	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;
  gtk_widget_modify_bg (tab_rule_def_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_rule_properties_label_bg, GTK_STATE_NORMAL, &color);


 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
  
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Rule.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(rule->name, "#000000");
  tab_rule_tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_rule_tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_rule_tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_rule_tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_rule_tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Rule Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
 	
 	image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);
  
  // connect signals
	g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_rule_close_clicked),
                    tab_rule_main);
                    
  g_signal_connect ((gpointer) create_object, "clicked",
                    G_CALLBACK (on_tab_rule_create_new_object_clicked),
                    tab_rule_main);
                    
	g_signal_connect ((gpointer) drop_object, "clicked",
                    G_CALLBACK (on_tab_rule_drop_object_clicked),
                    tab_rule_main);
                                        
  g_signal_connect ((gpointer) apply_changes, "clicked",
                    G_CALLBACK (on_tab_rule_apply_changes_clicked),
                    tab_rule_main);
                     
  //init definition code textview
	init_text_view( tab_rule_def_text, TRUE, rule->definition);
	
	// definition callback
  GtkTextBuffer * buffer;
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (tab_rule_def_text));
  
 	g_signal_connect (G_OBJECT (buffer), "changed", 
                  G_CALLBACK (definition_insert_text), tab_rule_main);
                    
	// Fill in properties
	gint height = 1;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name", rule->name);
	height += 21;
	add_comment_entry_property("property_comment", tab_rule_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", rule->comment);
	height += 41;
	text = itoa_n(rule->OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Rule",  PIXMAP_DIRECTORY "/Rule.png");
	height += 21;
	gchar *event[] = {"Select", "Insert", "Update", "Delete"};
	gint id = -1;
	for(int i = 0; i < 4; i++){
		if(strcmp(event[i], rule->event) == 0) id = i;
	}
	add_combo_property("property_event", tab_rule_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Event", event,  4, id);
	height += 21;
	add_toggle_property("property_instead", tab_rule_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Instead", rule->instead, TRUE);
	height += 21;
	add_comment_entry_property("property_condition", tab_rule_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Condition", rule->condition);
	height += 41;
	gtk_widget_set_size_request (scrolledwindow97, -1, height);
	
	// show dependencies
	show_dependencies(GTK_TREE_VIEW(tab_rule_depen_dep_on), GTK_TREE_VIEW(tab_rule_depen_ref_by), &(rule->dep_on), &(rule->ref_by));
	
	//init sql code textview
	gchar * parent = NULL;
	parent = append_string(parent, o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name);
	parent = append_string(parent, "\".\"");
	parent = append_string(parent, rule->parent_name);
	
	gchar * sql = create_new_rule_SQL_query(rule, parent, TRUE, TRUE);
	init_text_view( tab_rule_sql_code, FALSE, sql);
	free(sql);	
	free(parent);
	
	// create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_rule_main;
	page->path = path;
	page->object = rule;
	page->close_function = on_tab_rule_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, rule->name);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}
}

/*
 * Close properties panel
 */
gboolean
on_tab_rule_close_clicked (GtkButton  *button, gpointer         user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		gtk_widget_destroy(GTK_WIDGET(user_data));
	}
	else{ // widget found
		if(page->modified){
			gchar * object_type = normal_text_with_color("Rule", "#000000");
			
		gchar * object_name;
			gchar * o_name = NULL;
			o_name = append_string(o_name, ((T_Rule *) page->object)->parent_name);
			o_name = append_string(o_name, ".");
			o_name = append_string(o_name, ((T_Rule *) page->object)->name);
			
			object_name = bold_text(o_name, "#980F0F");
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_type")), object_type);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_name")), object_name);
			free(object_type);
			free(object_name);
	
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "question_dialog")));
			if(res == GTK_RESPONSE_YES){ // Yes
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				
				on_tab_rule_apply_changes_clicked(NULL, user_data);
				
				remove_page_from_list( &notebook, page);
			}
			else if(res == GTK_RESPONSE_NO){ // No
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				remove_page_from_list( &notebook, page);
			}
			else{ // Cancel
			  gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
			  return FALSE;
			}
		}
		else remove_page_from_list( &notebook, page);
	}
	
	
	return TRUE;
} // on_tab_rule_close_clicked ()

/*
 * Apply changes
 */
void
on_tab_rule_apply_changes_clicked (GtkButton *button, gpointer user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		// new rule struct 
		T_Rule * new_rule, *old_rule;
		if( (new_rule = (T_Rule *) malloc (sizeof(T_Rule))) == NULL){
		   	fprintf(stderr, "Memory allocation error.");
	 			exit(0);
		}

		old_rule = (T_Rule *) page->object;

		// get properties
		GtkWidget * dialog = GTK_WIDGET(user_data);

		// name
		new_rule->name = copy_string(old_rule->name);
		
		// comment
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_comment");
		if(wid != NULL){
			GtkTextBuffer * buffer;
			buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
			GtkTextIter start, end;
  		gtk_text_buffer_get_start_iter(buffer, &start);
  		gtk_text_buffer_get_end_iter(buffer, &end);
			new_rule->comment = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
		}
		else new_rule->comment = copy_string("");

		// event
		wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_event");
		if(wid != NULL){
			new_rule->event = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
		}
		else new_rule->event = copy_string("");
		
		// instead
		wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_instead");
		if(wid != NULL){
			new_rule->instead = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
		}
		else new_rule->instead = FALSE;
	
		// condition
		wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_condition");
		if(wid != NULL){
			GtkTextBuffer * buffer;
			buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
			GtkTextIter start, end;
  		gtk_text_buffer_get_start_iter(buffer, &start);
  		gtk_text_buffer_get_end_iter(buffer, &end);
			new_rule->condition = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
		}
		else new_rule->condition = copy_string("");
	
		// definition
		wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_definition");
		if(wid != NULL){
			GtkTextBuffer * buffer;
			buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
			GtkTextIter start, end;
  		gtk_text_buffer_get_start_iter(buffer, &start);
  		gtk_text_buffer_get_end_iter(buffer, &end);
			new_rule->definition = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
		}
		else new_rule->definition = copy_string("");
		
		// parent_name
		gchar * parent_name = NULL;
	
		wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_schema");
		if(wid != NULL){
			gchar * markup = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
			parent_name = append_string(parent_name, "");
			parent_name = append_string(parent_name, markup);
			free(markup);
		}
		else parent_name = copy_string("");
		wid = get_widget_child_by_name(dialog, "property_parent");
		if(wid != NULL){
			gchar * m = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
			gint k = 0;
			while(m[k] != '.') k++;
			m[k] = '\0';
			parent_name = append_string(parent_name, "\".\"");
			parent_name = append_string(parent_name, m);
			m[k] = '.';
			free(m);
		}
		else parent_name = append_string(parent_name, "");

	// get profile		
	GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	T_Profile * profile = NULL;
	if(depth >=3 ){
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
	
		gchar * sql = NULL; 
		sql = create_edit_rule_SQL_query(old_rule, new_rule, parent_name);
		gboolean cancel = FALSE;
		if(sql != NULL){
			cancel = !execute_sql(sql, NULL, NULL, profile, TRUE, TRUE);
			if(!cancel){
				page->modified = FALSE;
			 gui_refresh(o_tree.server[intpath[0]], profile);
			}
			free(sql);
		}
		else{
			page->modified = FALSE;
			gui_refresh(o_tree.server[intpath[0]], profile);
		}
		
		free(parent_name);
		free(new_rule->name);
		free(new_rule->definition);
		free(new_rule->comment);
		free(new_rule->event);
		free(new_rule->condition);
		free(new_rule);
	  
	  if(cancel) return;

	}
} // on_tab_rule_apply_changes_clicked ()

/*
 * Create new object
 */
void
on_tab_rule_create_new_object_clicked (GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		run_c_rule_wizard(profile);
	}
} // on_tab_rule_create_new_object_clicked ()

/*
 * Drop object
 */
void
on_tab_rule_drop_object_clicked (GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth == 7 || depth == 9){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		
			// get object name and database profile
			gchar * parent_name = NULL;
			if(depth == 7){
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->name);
				parent_name = append_string(parent_name, "\".\"");
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->rule[intpath[6]]->parent_name);
			}
			else{
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->name);
				parent_name = append_string(parent_name, "\".\"");
				if(intpath[5] == 0) parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->table[intpath[6]]->name);
				else parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->view[intpath[6]]->name);
			}
				
			// run dialog to confirm delete
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")), FALSE);
			gchar * label = append_string(NULL, "Do you really want to drop rule '");
			if(depth == 7){
				label = append_string(label, profile->database.schema[intpath[4]]->rule[intpath[6]]->parent_name);
				label = append_string(label, ".");		
				label = append_string(label, profile->database.schema[intpath[4]]->rule[intpath[6]]->name);	
			}
			else{
				if(intpath[5] == 0){
					label = append_string(label, profile->database.schema[intpath[4]]->table[intpath[6]]->name);
					label = append_string(label, ".");		
					label = append_string(label, profile->database.schema[intpath[4]]->table[intpath[6]]->rule[intpath[8]]->name);	
				}
				else{
					label = append_string(label, profile->database.schema[intpath[4]]->view[intpath[6]]->name);
					label = append_string(label, ".");		
					label = append_string(label, profile->database.schema[intpath[4]]->view[intpath[6]]->rule[intpath[8]]->name);	
				}
			}
			label = append_string(label, "'?");
			gchar * l = normal_text(label);
			free(label);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml,"drop_dialog_label")), l);
			free(l);
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "drop_dialog")));
			gboolean cascade = FALSE;
			if(res == GTK_RESPONSE_YES){
				cascade = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")));
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));
			}
			else{
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));	
				return;
			}
		
			// create sql code
			gchar * sql = create_drop_rule_SQL_query((depth == 7) ? profile->database.schema[intpath[4]]->rule[intpath[6]] : ((intpath[5] == 0) ? profile->database.schema[intpath[4]]->table[intpath[6]]->rule[intpath[8]] : profile->database.schema[intpath[4]]->view[intpath[6]]->rule[intpath[8]]), parent_name, cascade);
			free(parent_name);
		
		
			// execute sql
			if(sql != NULL){
				if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
				  free(sql);
				  gui_refresh(server, profile);
				}
				else free(sql);
			}
		}
	}
} // on_tab_rule_drop_object_clicked ()

/*
 * Rule definition changed
 */
void
definition_insert_text  (GtkTextBuffer *textbuffer, gpointer user_data){
	T_Page * page = NULL;
	page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data));
	if(page != NULL){
	  page->modified = TRUE;
	  gchar * text = normal_text((page->modified)? "Modified": "");
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "statusbar_label2")), text);
		free(text);
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "apply_changes");
		if(wid != NULL)	gtk_widget_show(wid);	
	}  
} // definition_insert_text ()
