/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "table.h"
#include "../database/create_db_objects.h"
#include "../database/edit_db_objects.h"
#include "../database/drop_db_objects.h"
#include "../database/get_db_objects.h"
#include "../GUI_wizards/table_wizard.h"
#include "other_objects.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"
#include "../GUI/treeview_functions.h"

/*
 * Creates properties panel
 */
void
create_table_info(GtkWidget * main_notebook ,T_Table * table, gchar * path)
{
	GtkWidget *tab_table_main;	
	
	GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;
	
	GtkWidget *tab_table;
  GtkWidget *tab_table_vapend;
  GtkWidget *tab_table_objects;
  GtkWidget *tab_table_o_label_bg;
  GtkWidget *hbox73;
  GtkWidget *tab_table_o_label_img;
  GtkWidget *tab_table_o_label;
  GtkWidget *tab_table_object_notebook;
  GtkWidget *tab_table_fields;
  GtkWidget *tab_table_fields_list;
  GtkWidget *tab_table_fields_label;
  GtkWidget *tab_table_indexes;
  GtkWidget *tab_table_indexes_list;
  GtkWidget *tab_table_indexes_label;
  GtkWidget *tab_table_fkeys;
  GtkWidget *tab_table_fkeys_list;
  GtkWidget *tab_table_fkeys_label;
  GtkWidget *tab_table_checks;
  GtkWidget *tab_table_checks_list;
  GtkWidget *tab_table_checks_label;
  GtkWidget *tab_table_triggers;
  GtkWidget *tab_table_triggers_list;
  GtkWidget *tab_table_triggers_label;
  GtkWidget *tab_table_rules;
  GtkWidget *tab_table_rules_list;
  GtkWidget *tab_table_rules_label;
  GtkWidget *tab_table_references;
  GtkWidget *tab_table_references_list;
  GtkWidget *tab_table_references_label;
  GtkWidget *tab_table_properties;
  GtkWidget *tab_table_properties_label_bg;
  GtkWidget *hbox74;
  GtkWidget *tab_table_properties_label_img;
  GtkWidget *tab_table_properties_label;
  GtkWidget *scrolledwindow46;
  GtkWidget *viewport1;
  GtkWidget *label180;
  GtkWidget *data_tab;
  GtkWidget *hbox96;
  GtkWidget *eventbox3;
  GtkWidget *insert_data;
  GtkWidget *alignment57;
  GtkWidget *hbox97;
  GtkWidget *image263;
  GtkWidget *delete_data;
  GtkWidget *alignment58;
  GtkWidget *hbox98;
  GtkWidget *image264;
  GtkWidget *edit_data;
  GtkWidget *alignment59;
  GtkWidget *hbox99;
  GtkWidget *image265;
  GtkWidget *eventbox4;
  GtkWidget *first;
  GtkWidget *alignment60;
  GtkWidget *hbox100;
  GtkWidget *image266;
  GtkWidget *previous;
  GtkWidget *alignment61;
  GtkWidget *hbox101;
  GtkWidget *image267;
  GtkObject *limit_count_adj;
  GtkWidget *limit_count;
  GtkWidget *next;
  GtkWidget *alignment62;
  GtkWidget *hbox102;
  GtkWidget *image268;
  GtkWidget *last;
  GtkWidget *alignment63;
  GtkWidget *hbox103;
  GtkWidget *image269;
  GtkWidget *eventbox5;
  GtkWidget *fetch_all;
  GtkWidget *alignment64;
  GtkWidget *hbox104;
  GtkWidget *image270;
  GtkWidget *fetch_filtered;
  GtkWidget *alignment65;
  GtkWidget *hbox105;
  GtkWidget *image271;
  GtkWidget *eventbox6;
  GtkWidget *scrolledwindow136;
  GtkWidget *data_view;
  GtkWidget *label184;
  GtkWidget *tab_table_depen_hpend;
  GtkWidget *scrolledwindow47;
  GtkWidget *tab_table_depen_dep_on;
  GtkWidget *scrolledwindow48;
  GtkWidget *tab_table_depen_ref_by;
  GtkWidget *label181;
  GtkWidget *scrolledwindow49;
  GtkWidget *tab_table_permission_list;
  GtkWidget *label182;
  GtkWidget *scrolledwindow50;
  GtkWidget *tab_table_sql_code;
  GtkWidget *label183;
  
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();
  
  tab_table_main = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_table_main);
  // menu
   
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_table_main), menu, FALSE, TRUE, 0);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Table</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * object_name = normal_text_with_color(table->name, "#000000");
  object = gtk_label_new (object_name);
  gtk_widget_set_name(object, "property_table_name");
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Schema</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	T_Profile * profile; 
	T_Schema * schema;
	if(depth >=5 ){
		schema = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]];
		parent_name = normal_text_with_color(schema->name, "#000000");
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
  database = gtk_label_new (parent_name);
  gtk_widget_set_name(database, "property_schema_name");
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);

  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_table.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new table</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);

  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_table.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop table</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);
  
  // main window
  tab_table = gtk_notebook_new ();
  gtk_widget_show (tab_table);
  gtk_box_pack_start (GTK_BOX (tab_table_main), tab_table, TRUE, TRUE, 0);
   
  tab_table_vapend = gtk_vpaned_new ();
  gtk_widget_show (tab_table_vapend);
  gtk_container_add (GTK_CONTAINER (tab_table), tab_table_vapend);
  gtk_paned_set_position (GTK_PANED (tab_table_vapend), -1);

  tab_table_objects = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_table_objects);
  gtk_paned_pack1 (GTK_PANED (tab_table_vapend), tab_table_objects, TRUE, TRUE);

  tab_table_o_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_table_o_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_table_objects), tab_table_o_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_table_o_label_bg, -1, 21);

  hbox73 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox73);
  gtk_container_add (GTK_CONTAINER (tab_table_o_label_bg), hbox73);

  tab_table_o_label_img = create_pixmap(PIXMAP_DIRECTORY "/Schemas.png");
  gtk_widget_show (tab_table_o_label_img);
  gtk_box_pack_start (GTK_BOX (hbox73), tab_table_o_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_table_o_label_img), 0.52, 0.5);

  tab_table_o_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>label</span>");
  gtk_widget_show (tab_table_o_label);
  gtk_box_pack_start (GTK_BOX (hbox73), tab_table_o_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_o_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_table_o_label), 0, 0.99);

  tab_table_object_notebook = gtk_notebook_new ();
  gtk_widget_show (tab_table_object_notebook);
  gtk_box_pack_start (GTK_BOX (tab_table_objects), tab_table_object_notebook, TRUE, TRUE, 0);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (tab_table_object_notebook), GTK_POS_BOTTOM);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (tab_table_object_notebook), TRUE);

  tab_table_fields = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_fields);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_fields);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_fields), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_fields), GTK_SHADOW_IN);

  tab_table_fields_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_fields_list);
  gtk_container_add (GTK_CONTAINER (tab_table_fields), tab_table_fields_list);

  tab_table_fields_label = gtk_label_new ("<span font_desc='8'>Fields</span>");
  gtk_widget_show (tab_table_fields_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 0), tab_table_fields_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_fields_label), TRUE);

  tab_table_indexes = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_indexes);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_indexes);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_indexes), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_indexes), GTK_SHADOW_IN);

  tab_table_indexes_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_indexes_list);
  gtk_container_add (GTK_CONTAINER (tab_table_indexes), tab_table_indexes_list);

  tab_table_indexes_label = gtk_label_new ("<span font_desc='8'>Indexes</span>");
  gtk_widget_show (tab_table_indexes_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 1), tab_table_indexes_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_indexes_label), TRUE);

  tab_table_fkeys = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_fkeys);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_fkeys);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_fkeys), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_fkeys), GTK_SHADOW_IN);

  tab_table_fkeys_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_fkeys_list);
  gtk_container_add (GTK_CONTAINER (tab_table_fkeys), tab_table_fkeys_list);

  tab_table_fkeys_label = gtk_label_new ("<span font_desc='8'>Foreign Keys</span>");
  gtk_widget_show (tab_table_fkeys_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 2), tab_table_fkeys_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_fkeys_label), TRUE);

  tab_table_checks = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_checks);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_checks);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_checks), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_checks), GTK_SHADOW_IN);

  tab_table_checks_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_checks_list);
  gtk_container_add (GTK_CONTAINER (tab_table_checks), tab_table_checks_list);

  tab_table_checks_label = gtk_label_new ("<span font_desc='8'>Checks</span>");
  gtk_widget_show (tab_table_checks_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 3), tab_table_checks_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_checks_label), TRUE);

  tab_table_triggers = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_triggers);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_triggers);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_triggers), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_triggers), GTK_SHADOW_IN);

  tab_table_triggers_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_triggers_list);
  gtk_container_add (GTK_CONTAINER (tab_table_triggers), tab_table_triggers_list);

  tab_table_triggers_label = gtk_label_new ("<span font_desc='8'>Triggers</span>");
  gtk_widget_show (tab_table_triggers_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 4), tab_table_triggers_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_triggers_label), TRUE);

  tab_table_rules = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_rules);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_rules);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_rules), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_rules), GTK_SHADOW_IN);

  tab_table_rules_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_rules_list);
  gtk_container_add (GTK_CONTAINER (tab_table_rules), tab_table_rules_list);

  tab_table_rules_label = gtk_label_new ("<span font_desc='8'>Rules</span>");
  gtk_widget_show (tab_table_rules_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 5), tab_table_rules_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_rules_label), TRUE);

  tab_table_references = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (tab_table_references);
  gtk_container_add (GTK_CONTAINER (tab_table_object_notebook), tab_table_references);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tab_table_references), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (tab_table_references), GTK_SHADOW_IN);

  tab_table_references_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_references_list);
  gtk_container_add (GTK_CONTAINER (tab_table_references), tab_table_references_list);

  tab_table_references_label = gtk_label_new ("<span font_desc='8'>References</span>");
  gtk_widget_show (tab_table_references_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table_object_notebook), 6), tab_table_references_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_references_label), TRUE);

  tab_table_properties = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_table_properties);
  gtk_paned_pack2 (GTK_PANED (tab_table_vapend), tab_table_properties, FALSE, TRUE);

  tab_table_properties_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_table_properties_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_table_properties), tab_table_properties_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_table_properties_label_bg, -1, 21);

  hbox74 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox74);
  gtk_container_add (GTK_CONTAINER (tab_table_properties_label_bg), hbox74);

  tab_table_properties_label_img = create_pixmap(PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_table_properties_label_img);
  gtk_box_pack_start (GTK_BOX (hbox74), tab_table_properties_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_table_properties_label_img), 0.52, 0.5);

  tab_table_properties_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_table_properties_label);
  gtk_box_pack_start (GTK_BOX (hbox74), tab_table_properties_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_table_properties_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_table_properties_label), 0, 0.99);

  scrolledwindow46 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow46);
  gtk_box_pack_start (GTK_BOX (tab_table_properties), scrolledwindow46, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow46), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow46), GTK_SHADOW_NONE);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport1), GTK_SHADOW_NONE);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow46), viewport1);
	
	GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport1), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);
	
	label180 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label180);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table), 0), label180);
  gtk_label_set_use_markup (GTK_LABEL (label180), TRUE);

  data_tab = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (data_tab);
  gtk_container_add (GTK_CONTAINER (tab_table), data_tab);
	
	GtkWidget * data_tab_hr = gtk_event_box_new ();
	gtk_widget_show (data_tab_hr);
	gtk_box_pack_start (GTK_BOX (data_tab), data_tab_hr, FALSE, TRUE, 0);
	
  hbox96 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox96);
  gtk_container_add (GTK_CONTAINER (data_tab_hr), hbox96);

  eventbox3 = gtk_event_box_new ();
  gtk_widget_show (eventbox3);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox3, TRUE, TRUE, 0);

  insert_data = gtk_button_new ();
  gtk_widget_show (insert_data);
  gtk_box_pack_start (GTK_BOX (hbox96), insert_data, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, insert_data, "Insert", NULL);
	gtk_button_set_relief (GTK_BUTTON (insert_data), GTK_RELIEF_NONE);
	
  alignment57 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment57);
  gtk_container_add (GTK_CONTAINER (insert_data), alignment57);

  hbox97 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox97);
  gtk_container_add (GTK_CONTAINER (alignment57), hbox97);

  image263 = gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image263);
  gtk_box_pack_start (GTK_BOX (hbox97), image263, FALSE, FALSE, 0);

  delete_data = gtk_button_new ();
  gtk_widget_show (delete_data);
  gtk_box_pack_start (GTK_BOX (hbox96), delete_data, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, delete_data, "Delete", NULL);
	gtk_button_set_relief (GTK_BUTTON (delete_data), GTK_RELIEF_NONE);
	
  alignment58 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment58);
  gtk_container_add (GTK_CONTAINER (delete_data), alignment58);

  hbox98 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox98);
  gtk_container_add (GTK_CONTAINER (alignment58), hbox98);

  image264 = gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image264);
  gtk_box_pack_start (GTK_BOX (hbox98), image264, FALSE, FALSE, 0);

  edit_data = gtk_button_new ();
  gtk_widget_show (edit_data);
  gtk_box_pack_start (GTK_BOX (hbox96), edit_data, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, edit_data, "Edit", NULL);
	gtk_button_set_relief (GTK_BUTTON (edit_data), GTK_RELIEF_NONE);
	
  alignment59 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment59);
  gtk_container_add (GTK_CONTAINER (edit_data), alignment59);

  hbox99 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox99);
  gtk_container_add (GTK_CONTAINER (alignment59), hbox99);

  image265 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image265);
  gtk_box_pack_start (GTK_BOX (hbox99), image265, FALSE, FALSE, 0);

  eventbox4 = gtk_event_box_new ();
  gtk_widget_show (eventbox4);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox4, TRUE, TRUE, 0);

  first = gtk_button_new ();
  gtk_widget_show (first);
  gtk_box_pack_start (GTK_BOX (hbox96), first, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (first), GTK_RELIEF_NONE);
	
  alignment60 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment60);
  gtk_container_add (GTK_CONTAINER (first), alignment60);

  hbox100 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox100);
  gtk_container_add (GTK_CONTAINER (alignment60), hbox100);

  image266 = gtk_image_new_from_stock ("gtk-goto-first", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image266);
  gtk_box_pack_start (GTK_BOX (hbox100), image266, FALSE, FALSE, 0);

  previous = gtk_button_new ();
  gtk_widget_show (previous);
  gtk_box_pack_start (GTK_BOX (hbox96), previous, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (previous), GTK_RELIEF_NONE);
	
  alignment61 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment61);
  gtk_container_add (GTK_CONTAINER (previous), alignment61);

  hbox101 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox101);
  gtk_container_add (GTK_CONTAINER (alignment61), hbox101);

  image267 = gtk_image_new_from_stock ("gtk-go-back", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image267);
  gtk_box_pack_start (GTK_BOX (hbox101), image267, FALSE, FALSE, 0);

  limit_count_adj = gtk_adjustment_new (1000, 0, 60000, 1, 1, 1);
  limit_count = gtk_spin_button_new (GTK_ADJUSTMENT (limit_count_adj), 1, 0);
  gtk_widget_set_name(limit_count, "limit_count");
  gtk_widget_show (limit_count);
  gtk_box_pack_start (GTK_BOX (hbox96), limit_count, FALSE, FALSE, 0);
  gtk_widget_set_size_request (limit_count, 80, -1);
  gtk_tooltips_set_tip (tooltips, limit_count, "Limit count (0 for no limit)", NULL);
	g_object_set (limit_count, "has_frame", FALSE, NULL);
	
  next = gtk_button_new ();
  gtk_widget_show (next);
  gtk_box_pack_start (GTK_BOX (hbox96), next, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (next), GTK_RELIEF_NONE);
	
  alignment62 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment62);
  gtk_container_add (GTK_CONTAINER (next), alignment62);

  hbox102 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox102);
  gtk_container_add (GTK_CONTAINER (alignment62), hbox102);

  image268 = gtk_image_new_from_stock ("gtk-go-forward", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image268);
  gtk_box_pack_start (GTK_BOX (hbox102), image268, FALSE, FALSE, 0);

  last = gtk_button_new ();
  gtk_widget_show (last);
  gtk_box_pack_start (GTK_BOX (hbox96), last, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (last), GTK_RELIEF_NONE);
	
  alignment63 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment63);
  gtk_container_add (GTK_CONTAINER (last), alignment63);

  hbox103 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox103);
  gtk_container_add (GTK_CONTAINER (alignment63), hbox103);

  image269 = gtk_image_new_from_stock ("gtk-goto-last", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image269);
  gtk_box_pack_start (GTK_BOX (hbox103), image269, FALSE, FALSE, 0);

  eventbox5 = gtk_event_box_new ();
  gtk_widget_show (eventbox5);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox5, TRUE, TRUE, 0);

  fetch_all = gtk_button_new ();
  gtk_widget_show (fetch_all);
  gtk_box_pack_start (GTK_BOX (hbox96), fetch_all, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, fetch_all, "Fetch all records", NULL);
	gtk_button_set_relief (GTK_BUTTON (fetch_all), GTK_RELIEF_NONE);
	
  alignment64 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment64);
  gtk_container_add (GTK_CONTAINER (fetch_all), alignment64);

  hbox104 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox104);
  gtk_container_add (GTK_CONTAINER (alignment64), hbox104);

  image270 = gtk_image_new_from_stock ("gtk-goto-bottom", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image270);
  gtk_box_pack_start (GTK_BOX (hbox104), image270, FALSE, FALSE, 0);

  fetch_filtered = gtk_button_new ();
  gtk_widget_show (fetch_filtered);
  gtk_box_pack_start (GTK_BOX (hbox96), fetch_filtered, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, fetch_filtered, "Fetch filtered records", NULL);
	gtk_button_set_relief (GTK_BUTTON (fetch_filtered), GTK_RELIEF_NONE);
	
  alignment65 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment65);
  gtk_container_add (GTK_CONTAINER (fetch_filtered), alignment65);

  hbox105 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox105);
  gtk_container_add (GTK_CONTAINER (alignment65), hbox105);

  image271 = gtk_image_new_from_stock ("gtk-go-down", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image271);
  gtk_box_pack_start (GTK_BOX (hbox105), image271, FALSE, FALSE, 0);

  eventbox6 = gtk_event_box_new ();
  gtk_widget_show (eventbox6);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox6, TRUE, TRUE, 0);

  scrolledwindow136 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow136);
  gtk_box_pack_start (GTK_BOX (data_tab), scrolledwindow136, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow136), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow136), GTK_SHADOW_IN);

  data_view = gtk_tree_view_new ();
  gtk_widget_set_name(data_view,"data_view");
  gtk_widget_show (data_view);
  gtk_container_add (GTK_CONTAINER (scrolledwindow136), data_view);

  label184 = gtk_label_new ("<span font_desc='Italic 8'>Data</span>");
  gtk_widget_show (label184);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table), 1), label184);
  gtk_label_set_use_markup (GTK_LABEL (label184), TRUE);

  tab_table_depen_hpend = gtk_hpaned_new ();
  gtk_widget_show (tab_table_depen_hpend);
  gtk_container_add (GTK_CONTAINER (tab_table), tab_table_depen_hpend);
  gtk_paned_set_position (GTK_PANED (tab_table_depen_hpend), -1);

  scrolledwindow47 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow47);
  gtk_paned_pack1 (GTK_PANED (tab_table_depen_hpend), scrolledwindow47, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow47), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow47), GTK_SHADOW_IN);

  tab_table_depen_dep_on = gtk_tree_view_new ();
  gtk_widget_show (tab_table_depen_dep_on);
  gtk_container_add (GTK_CONTAINER (scrolledwindow47), tab_table_depen_dep_on);

  scrolledwindow48 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow48);
  gtk_paned_pack2 (GTK_PANED (tab_table_depen_hpend), scrolledwindow48, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow48), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow48), GTK_SHADOW_IN);

  tab_table_depen_ref_by = gtk_tree_view_new ();
  gtk_widget_show (tab_table_depen_ref_by);
  gtk_container_add (GTK_CONTAINER (scrolledwindow48), tab_table_depen_ref_by);

  label181 = gtk_label_new ("<span font_desc='Italic 8'>Dependencies</span>");
  gtk_widget_show (label181);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table), 2), label181);
  gtk_label_set_use_markup (GTK_LABEL (label181), TRUE);

  scrolledwindow49 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow49);
  gtk_container_add (GTK_CONTAINER (tab_table), scrolledwindow49);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow49), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow49), GTK_SHADOW_IN);

  tab_table_permission_list = gtk_tree_view_new ();
  gtk_widget_show (tab_table_permission_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow49), tab_table_permission_list);

  label182 = gtk_label_new ("<span font_desc='Italic 8'>Permissions</span>");
  gtk_widget_show (label182);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table), 3), label182);
  gtk_label_set_use_markup (GTK_LABEL (label182), TRUE);

  scrolledwindow50 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow50);
  gtk_container_add (GTK_CONTAINER (tab_table), scrolledwindow50);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow50), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow50), GTK_SHADOW_IN);

  tab_table_sql_code = gtk_text_view_new ();
  gtk_widget_show (tab_table_sql_code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow50), tab_table_sql_code);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_table_sql_code), 7);

  label183 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label183);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_table), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_table), 4), label183);
  gtk_label_set_use_markup (GTK_LABEL (label183), TRUE);

   
  // create page label
 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_label;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
 
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Table.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(table->name, "#000000");
  tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Table Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
 
  image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);
	
	// Show properties	
	gint height = 0;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_entry_property("property_name", tab_table_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name",  table->name);
	height += 21;	
	T_Roles * roles = get_roles(profile, FALSE);
	if(roles != NULL){
		gint role_id=-1;
		for(int i = 0; i < roles->n_roles; i++){
			if(strcmp(roles->name[i], table->owner) == 0){
				role_id = i;
				break;
			}
		}
		add_combo_property("property_owner", tab_table_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Owner", roles->name,  roles->n_roles, role_id);
		for(int i = 0; i < roles->n_roles; i++){
			free(roles->name[i]);
		}
		free(roles->name);
		free(roles);
	}
	height += 21;	
	add_comment_entry_property("property_comment", tab_table_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", table->comment);
	height += 41;
	text = itoa_n(table->OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Table",  PIXMAP_DIRECTORY "/Table.png");
	height += 21;
	add_toggle_property("property_with_OIDs", tab_table_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "With OIDs",  table->WithOIDs, FALSE);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Inherited From", table->inherited_from);
	height += 21;
	T_Tablespaces * tspces = get_Tablespaces(profile);
	if(tspces != NULL){
		gint tspc_id=-1;
		for(int i = 0; i < tspces->n_tablespaces; i++){
			if(strcmp(tspces->name[i], table->tablespace) == 0){
				tspc_id = i;
				break;
			}
		}
		add_combo_property("property_tablespace", tab_table_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Tablespace", tspces->name,  tspces->n_tablespaces, tspc_id);
		for(int i = 0; i < tspces->n_tablespaces; i++){
			free(tspces->name[i]);
		}
		free(tspces->name);
		free(tspces);
	}
	height += 21;	
	gtk_widget_set_size_request (scrolledwindow46, -1, height);	
	
	// show sub objects
	// fields
	gint n = table->n_columns;
	
	GType ftypes[8];
	ftypes[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_fields_list), 0);
	ftypes[1] = GDK_TYPE_PIXBUF;
	ftypes[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_fields_list), "Name", 1);
	ftypes[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fields_list), "Type", 3);
	ftypes[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fields_list),"Unique", 4);
	ftypes[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fields_list),"Not Null", 5);
	ftypes[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fields_list),"Default", 6);
	ftypes[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fields_list),"Comment", 7);
	GtkTreeModel * model = GTK_TREE_MODEL(gtk_list_store_newv(8, ftypes));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->column[i]->name,"#980F0F");
		gchar * text2 = normal_text(table->column[i]->type);
		gchar * text3 = normal_text((table->column[i]->unique) ? "True" : "False");
		gchar * text4 = normal_text((table->column[i]->not_null) ? "True" : "False");
		gchar * text5 = normal_text(table->column[i]->default_value);
		gchar * text6 = normal_text(table->column[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, (table->column[i]->pkey) ? get_icon(PIXMAP_DIRECTORY "/FieldPK.png") : get_icon(PIXMAP_DIRECTORY "/Field.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_fields_list)), model);
  
  // indexes
	n = table->n_indexes;
	
	GType ind_types[11];
	ind_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_indexes_list), 0);
	ind_types[1] = GDK_TYPE_PIXBUF;
	ind_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_indexes_list), "Name", 1);
	ind_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list), "Field Names", 3);
	ind_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Primary", 4);
	ind_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Unique", 5);
	ind_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Clustered", 6);
	ind_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Type", 7);
	ind_types[8] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Predicate", 8);
	ind_types[9] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Tablespace", 9);
	ind_types[10] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_indexes_list),"Comment", 10);
	
	model = GTK_TREE_MODEL(gtk_list_store_newv(11, ind_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->index[i]->name,"#980F0F");
		
		gchar * cols = NULL;
		for(int j = 0; j < table->index[i]->n_columns; j++){
			cols = append_string(cols, table->index[i]->column[j]->name);
			if(j < (table->index[i]->n_columns-1)) cols = append_string(cols, ", ");
		}
		gchar * text2 = normal_text(cols);
		free(cols);
		gchar * text3 = normal_text((table->index[i]->pkey_constraint) ? "True" : "False");
		gchar * text4 = normal_text((table->index[i]->unique_index) ? "True" : "False");
		gchar * text5 = normal_text((table->index[i]->clustered) ? "True" : "False");
		gchar * text6 = normal_text(table->index[i]->access_method);
		gchar * text7 = normal_text(table->index[i]->predicate);
		gchar * text8 = normal_text(table->index[i]->tablespace);
		gchar * text9 = normal_text(table->index[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Index.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, 8, text7, 9, text8, 10, text9, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7); free(text8); free(text9);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_indexes_list)), model);

	// Foreign Keys
	n = table->n_fkeys;
	
	GType fk_types[10];
	fk_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_fkeys_list), 0);
	fk_types[1] = GDK_TYPE_PIXBUF;
	fk_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_fkeys_list), "Name", 1);
	fk_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list), "Field Names", 3);
	fk_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list),"Foreign Table", 4);
	fk_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list),"Foreign Field Names", 5);
	fk_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list),"Delete Role", 6);
	fk_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list),"Update Role", 7);
	fk_types[8] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list),"Deferrable", 8);
	fk_types[9] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_fkeys_list),"Comment", 9);
	
	model = GTK_TREE_MODEL(gtk_list_store_newv(10, fk_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->fkey[i]->name,"#980F0F");
		
		gchar * cols = NULL;
		for(int j = 0; j < table->fkey[i]->n_columns; j++){
			cols = append_string(cols, table->fkey[i]->column[j]->name);
			if(j < (table->fkey[i]->n_columns-1)) cols = append_string(cols, ", ");
		}
		gchar * text2 = normal_text(cols);
		free(cols);
		
		cols = append_string(NULL, table->fkey[i]->ref_schema);
		cols = append_string(cols, ".");
		cols = append_string(cols, table->fkey[i]->ref_table);
		gchar * text3 = normal_text(cols);
		free(cols);
		
		cols = NULL;
		for(int j = 0; j < table->fkey[i]->n_ref_columns; j++){
			cols = append_string(cols, table->fkey[i]->ref_column[j]->name);
			if(j < (table->fkey[i]->n_ref_columns-1)) cols = append_string(cols, ", ");
		}
		gchar * text4 = normal_text(cols);
		free(cols);
		
		gchar * text5 = normal_text(table->fkey[i]->on_delete_rule);
		gchar * text6 = normal_text(table->fkey[i]->on_update_rule);
		gchar * text7 = normal_text((table->fkey[i]->deferrable) ? "True" : "False");
		gchar * text8 = normal_text(table->fkey[i]->comment);
		
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/ForeignKey.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, 8, text7, 9, text8, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7); free(text8);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_fkeys_list)), model);

	// check
	n = table->n_checks;
	
	GType ch_types[5];
	ch_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_checks_list), 0);
	ch_types[1] = GDK_TYPE_PIXBUF;
	ch_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_checks_list), "Name", 1);
	ch_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_checks_list), "Condition", 3);
	ch_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_checks_list),"Comment", 4);
	model = GTK_TREE_MODEL(gtk_list_store_newv(5, ch_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->check[i]->name,"#980F0F");
		gchar * text2 = normal_text(table->check[i]->condition);
		gchar * text3 = normal_text(table->check[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Check.png"), 2, text1, 3, text2, 4, text3, -1);
		free(t); free(text); free(text1); free(text2); free(text3);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_checks_list)), model);
		
	// Triggers
	n = table->n_triggers;
	
	GType trig_types[8];
	trig_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_triggers_list), 0);
	trig_types[1] = GDK_TYPE_PIXBUF;
	trig_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_triggers_list), "Name", 1);
	trig_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_triggers_list), "Enabled", 3);
	trig_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_triggers_list),"Type", 4);
	trig_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_triggers_list),"Event(s)", 5);
	trig_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_triggers_list),"Function", 6);
	trig_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_triggers_list),"Comment", 7);	

	model = GTK_TREE_MODEL(gtk_list_store_newv(8, trig_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->trigger[i]->name,"#980F0F");
		gchar * text2 = normal_text((table->trigger[i]->enabled) ? "True" : "False");
		gchar * text3 = normal_text(table->trigger[i]->type);
		gchar * text4 = normal_text(table->trigger[i]->events);
		gchar * text5 = normal_text(table->trigger[i]->function);
		gchar * text6 = normal_text(table->trigger[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Trigger.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_triggers_list)), model);

	// rules
	n = table->n_rules;
	
	GType rul_types[5];
	rul_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_rules_list), 0);
	rul_types[1] = GDK_TYPE_PIXBUF;
	rul_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_rules_list), "Name", 1);
	rul_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_rules_list), "Event", 3);
	rul_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_rules_list),"Instead", 4);
	rul_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_rules_list),"Condition", 5);
	rul_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_rules_list),"Comment", 6);
	
	model = GTK_TREE_MODEL(gtk_list_store_newv(7, rul_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->rule[i]->name,"#980F0F");
		gchar * text2 = normal_text(table->rule[i]->event);
		gchar * text3 = normal_text((table->rule[i]->instead) ? "True" : "False");
		gchar * text4 = normal_text(table->rule[i]->condition);
		gchar * text5 = normal_text(table->rule[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Rule.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_rules_list)), model);

	// Foreign key references
	n = table->n_references;
	
	GType ref_types[6];
	ref_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_table_references_list), 0);
	ref_types[1] = GDK_TYPE_PIXBUF;
	ref_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_table_references_list), "Name", 1);
	ref_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_references_list), "Field Names", 3);
	ref_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_references_list),"Foreign Table", 4);
	ref_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_table_references_list),"Foreign Field Names", 5);
		
	model = GTK_TREE_MODEL(gtk_list_store_newv(6, ref_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(table->reference[i]->name,"#980F0F");
		
		gchar * cols = NULL;
		for(int j = 0; j < table->reference[i]->n_columns; j++){
			cols = append_string(cols, table->reference[i]->column[j]->name);
			if(j < (table->reference[i]->n_columns-1)) cols = append_string(cols, ", ");
		}
		gchar * text2 = normal_text(cols);
		free(cols);
		
		cols = append_string(NULL, table->reference[i]->ref_schema);
		cols = append_string(cols,".");
		cols = append_string(cols, table->reference[i]->ref_table);
		gchar * text3 = normal_text(cols);
		free(cols);
		
		cols = NULL;
		for(int j = 0; j < table->reference[i]->n_ref_columns; j++){
			cols = append_string(cols, table->reference[i]->ref_column[j]->name);
			if(j < (table->reference[i]->n_ref_columns-1)) cols = append_string(cols, ", ");
		}
		gchar * text4 = normal_text(cols);
		free(cols);
		
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/ForeignKey.png"), 2, text1, 3, text2, 4, text3, 5, text4, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_table_references_list)), model);
	
	// show dependencies
	show_dependencies(GTK_TREE_VIEW(tab_table_depen_dep_on), GTK_TREE_VIEW(tab_table_depen_ref_by), &(table->dep_on), &(table->ref_by));
	
	gchar * sql = create_new_table_SQL_query(table, schema->name);
	//init sql code textview
	init_text_view(  tab_table_sql_code, FALSE, sql);
	free(sql);
	
	// Modify colors 
	GdkColor color;
	
	// menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox3, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox4, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox5, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox6, GTK_STATE_NORMAL, &color);    
  
  // main colors
  color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
	gtk_widget_modify_bg (tab_table_o_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_table_properties_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (data_tab_hr, GTK_STATE_NORMAL, &color);
  
	color.red = 236*257;
  color.green = 232*257;
  color.blue = 226*257;  
  gtk_widget_modify_bg (properties_background, GTK_STATE_NORMAL, &color);

	// connect signals
	g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_table_close_clicked),
                    tab_table_main);
              
  g_signal_connect ((gpointer) create_object, "clicked",
                    G_CALLBACK (on_tab_table_create_new_table_clicked),
                    tab_table_main);
                    
	g_signal_connect ((gpointer) drop_object, "clicked",
                    G_CALLBACK (on_tab_table_drop_table_clicked),
                    tab_table_main);
                                        
  g_signal_connect ((gpointer) apply_changes, "clicked",
                    G_CALLBACK (on_tab_table_apply_changes_clicked),
                    tab_table_main);
  
  g_signal_connect ((gpointer) tab_table_object_notebook, "switch-page",
                    G_CALLBACK (on_tab_table_objects_change_current_page),
                    hbox73);
  
  g_signal_connect ((gpointer) insert_data, "clicked",
                    G_CALLBACK (on_data_insert_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) delete_data, "clicked",
                    G_CALLBACK (on_data_delete_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) edit_data, "clicked",
                    G_CALLBACK (on_data_edit_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) first, "clicked",
                    G_CALLBACK (on_first_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) previous, "clicked",
                    G_CALLBACK (on_previous_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) next, "clicked",
                    G_CALLBACK (on_next_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) last, "clicked",
                    G_CALLBACK (on_last_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) fetch_all, "clicked",
                    G_CALLBACK (on_fetch_all_clicked),
                    tab_table_main);
  g_signal_connect ((gpointer) fetch_filtered, "clicked",
                    G_CALLBACK (on_fetch_filtered_clicked),
                    tab_table_main);               
   g_signal_connect ((gpointer) limit_count, "changed",
                    G_CALLBACK (on_limit_changed),
                    tab_table_main);    
                                 
  // init data
  table->data.rows = 0;
  table->data.cols = 0;
  table->data.limit = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(limit_count));
  table->data.offset = 0;
 	table->data.condition = NULL;

	// create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_table_main;
	page->path = path;
	page->object = table;
	page->close_function = on_tab_table_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, table->name);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(tab_table_object_notebook), 2);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(tab_table_object_notebook), 0);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}
}// create_table_info()

/*
 * Subobject notebook page changed
 */
void
on_tab_table_objects_change_current_page (GtkNotebook *nb, GtkNotebookPage *page, guint page_num, gpointer user_data)
{
	GList * children = gtk_container_get_children(GTK_CONTAINER(user_data));
	GtkWidget * label = NULL;
	GtkWidget * image = NULL;
	
	do{
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_LABEL) label = children->data;
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_IMAGE) image = children->data;
		children = children->next;
 	}while(children != NULL);
	
	switch(page_num){
	  case 0: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Fields.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Fields</span>");
									break;
		case 1: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Indexes.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Indexes</span>");
									break;
		case 2: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/ForeignKeys.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Foreign Keys</span>");
									break;
		case 3: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Checks.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Checks</span>");
									break;
		case 4: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Triggers.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Triggers</span>");
									break;
    case 5: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Rules.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Rules</span>");
									break;
		case 6: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/ForeignKeys.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>References</span>");
									break;																																
		}
} // on_tab_table_objects_change_current_page ()

/*
 * Close properties panel
 */
gboolean
on_tab_table_close_clicked(GtkButton  *button, gpointer         user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		gtk_widget_destroy(GTK_WIDGET(user_data));
	}
	else{ // widget found
		if(page->modified){
			gchar * object_type = normal_text_with_color("Table", "#000000");
			
			GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
			gint depth = gtk_tree_path_get_depth(path);
			gint * intpath = gtk_tree_path_get_indices(path);
			gchar * object_name;
			gchar * o_name = NULL;
			if(depth >= 7){
			  o_name = append_string(o_name, o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name);
			  o_name = append_string(o_name, ".");
			}
			o_name = append_string(o_name, ((T_Table *) page->object)->name);
			object_name = bold_text(o_name, "#980F0F");
			free(o_name);
			
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_type")), object_type);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_name")), object_name);
			free(object_type);
			free(object_name);
	
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "question_dialog")));
			if(res == GTK_RESPONSE_YES){ // Yes
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				
				on_tab_table_apply_changes_clicked(NULL, user_data);
				
				remove_page_from_list( &notebook, page);
			}
			else if(res == GTK_RESPONSE_NO){ // No
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				remove_page_from_list( &notebook, page);
			}
			else{ // Cancel
			  gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
			  return FALSE;
			}
		}
		else remove_page_from_list( &notebook, page);
	}
	
	
	return TRUE;
} // on_tab_table_close_clicked ()

/*
 * Apply changes
 */
void
on_tab_table_apply_changes_clicked(GtkButton *button, gpointer user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		// new profile struct 
		T_Table * new_table, *old_table;
		new_table = (T_Table *) malloc (sizeof(T_Table));
		if(new_table == NULL){
		   	fprintf(stderr, "Memory allocation error.");
	 			exit(0);
		}
		
		old_table = (T_Table *) page->object;
		
		// get properties
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_name");
		if(wid == NULL) return;
		new_table->name = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
		
		wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_owner");
		if(wid == NULL) return;
		new_table->owner = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
		
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_comment");
		if(wid == NULL) return;
		GtkTextBuffer * buffer;
		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
		GtkTextIter start, end;
  	gtk_text_buffer_get_start_iter(buffer, &start);
  	gtk_text_buffer_get_end_iter(buffer, &end);
		
		new_table->comment = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
		
		wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_tablespace");
		if(wid == NULL) return;
		new_table->tablespace = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
		
		
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		gchar * parent_name;
		if(depth >=5 ){
			parent_name = copy_string(o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name);
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		
		
		gchar * sql = create_edit_table_SQL_query(old_table, new_table, parent_name);
		if(sql != NULL){
			if(!execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
				free(sql);
				return;
			}
			page->modified = FALSE;
			gui_refresh(server, profile);
			free(sql);
		}
		else{
			page->modified = FALSE;
			gui_refresh(server, profile);
		}
			
		free(parent_name);
		free(new_table->name);
		free(new_table->owner);
		free(new_table->comment);
		free(new_table->tablespace);
		free(new_table);
	
	}
} // on_tab_table_apply_changes_clicked ()

/*
 * Create new object
 */
void
on_tab_table_create_new_table_clicked (GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		run_c_table_wizard(profile);
	}
} // on_tab_table_create_new_table_clicked ()

/*
 * Drop object
 */
void
on_tab_table_drop_table_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth ==7 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		
			// run dialog to confirm delete
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")), FALSE);
			gchar * label = append_string(NULL, "Do you really want to drop table '");
			label = append_string(label, profile->database.schema[intpath[4]]->name);
			label = append_string(label, ".");		
			label = append_string(label, profile->database.schema[intpath[4]]->table[intpath[6]]->name);	
			label = append_string(label, "'?");
			gchar * l = normal_text(label);
			free(label);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml,"drop_dialog_label")), l);
			free(l);
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "drop_dialog")));
			gboolean cascade = FALSE;
			if(res == GTK_RESPONSE_YES){
				cascade = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")));
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));
			}
			else{
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));	
				return;
			}
		
			// create sql code
			gchar * sql = create_drop_table_SQL_query(profile->database.schema[intpath[4]]->table[intpath[6]], profile->database.schema[intpath[4]]->name, cascade);
		
			// execute sql
			if(sql != NULL){
				if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
					free(sql);
					page->modified = FALSE;
				  gui_refresh(server, profile);
				}
				else free(sql);
			}
		}
	}
} // on_tab_table_drop_table_clicked ()

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* ------------------------------------ data retrieving -------------------------------------------------- */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
 * Function for data insert
 */
void
on_data_insert_clicked(GtkButton *button, gpointer user_data){
	init_op_dialog();
	
	gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "label203")), "<span font_desc='9 Bold' foreground='#FFFFFF'>Data</span>");
	
	gtk_widget_set_sensitive(glade_xml_get_widget(xml, "opd_ok"), TRUE);
	
	GtkWidget * dialog = glade_xml_get_widget(xml, "object_properties_dialog");
	// set title
	gtk_window_set_title(GTK_WINDOW(dialog), "Table insert data");
	
	// add properties
	GtkWidget * properties_columns = glade_xml_get_widget(xml, "opd_properties");
  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_set_name(properties_column1, "properties_column1");
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_set_name(properties_column2, "properties_column2");
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);
  
  // get table name
  T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		gchar * table = NULL;
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_table_name");
		if(wid != NULL) table = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
		
		gchar * schema = NULL;
		wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_schema_name");
		if(wid != NULL) schema = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
		
  	// get columns
  	wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "data_view");
		if(wid == NULL) return;
		
		GList * list = NULL, *pom_list = NULL;
  	list = gtk_tree_view_get_columns(GTK_TREE_VIEW(wid));
  	if(list == NULL) return;
 	 	gint height = 0;
		add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), table,  PIXMAP_DIRECTORY "/Table.png");
		height += 21;
		for(list = list->next; list != NULL; list = list->next){
			GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
			pom_list = g_list_append(pom_list, col);
			gchar * name = copy_string(gtk_tree_view_column_get_title(col));
			add_entry_property(name, dialog, GTK_BOX(properties_column1), GTK_BOX(properties_column2), name, "");
			free(name);
			height += 21;	
		}
		gtk_widget_set_size_request (glade_xml_get_widget(xml, "scrolledwindow11"), -1, height);
		
		// get profile		
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Profile * profile = NULL;
		if(depth >=3 ){
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		
		// run dialog
  	gboolean end = FALSE;
  	do{
  		end = FALSE;
  	gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "object_properties_dialog")));
  	if(res == GTK_RESPONSE_OK){
  		gchar * sql = NULL;
  		
  		// get values from dialog
  		sql = append_string(sql, "INSERT INTO \"");
  		sql = append_string(sql, schema);
  		sql = append_string(sql, "\".\"");
  		sql = append_string(sql, table);
  		sql = append_string(sql, "\" (\"");
  		list = pom_list;
  		if(list != NULL){
  			for(; list != NULL; list = list->next){
  				GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
					gchar * name = copy_string(gtk_tree_view_column_get_title(col));
					sql = append_string(sql, name);
					if(list->next != NULL) sql = append_string(sql, "\", \"");
  			}
  			sql = append_string(sql, "\")\n  VALUES (");
  			list = pom_list;
  			for(; list != NULL; list = list->next){
  				GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
					gchar * name = copy_string(gtk_tree_view_column_get_title(col));
					wid = NULL;
					wid = get_widget_child_by_name(dialog, name);
					gchar * value = NULL;
					if(wid != NULL) value = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
					else value = copy_string("");
					sql = append_string(sql, "\'");
					sql = append_string(sql, value);
					sql = append_string(sql, "\'");
					free(value);
					if(list->next != NULL) sql = append_string(sql, ", ");
  			}  			
  			sql = append_string(sql, ");\n");
  			
  			// execute SQL query
  			if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
  				on_last_clicked(NULL, user_data);
  				end = TRUE;
  			}
  			
  			free(sql);
  		}
  	}
  	else end = TRUE;
		}while(!end);
  	gtk_widget_hide(glade_xml_get_widget(xml, "object_properties_dialog"));
  	free(table);
  	free(schema);
  	g_list_free(list);
  	g_list_free(pom_list);
	}
	
	gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "label203")), "<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
} // on_data_insert_clicked()

/*
 * Functin for data delete
 */
void
on_data_delete_clicked(GtkButton *button, gpointer user_data){
	// get table name
  T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		gchar * table = NULL;
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_table_name");
		if(wid != NULL) table = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
		
		gchar * schema = NULL;
		wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_schema_name");
		if(wid != NULL) schema = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
		
		// get profile		
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Profile * profile = NULL;
		if(depth >=3 ){
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		
  	// get columns
  	wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "data_view");
		if(wid == NULL) return;
		
		GList * list = NULL;
  	list = gtk_tree_view_get_columns(GTK_TREE_VIEW(wid));
  	if(list == NULL) return;
  	
  	// get selected row
		GtkTreeSelection * selection;
		GtkTreeView * view = GTK_TREE_VIEW(wid);
		GtkTreeModel * model = gtk_tree_view_get_model(view);
		GtkTreeIter iter;
		selection = gtk_tree_view_get_selection(view);
		if(!gtk_tree_selection_get_selected(selection, &model, &iter)) return;
		
		// confirm remove
		gchar * label = append_string(NULL, "Do you really want to remove selected row?");
		gchar * l = normal_text(label);
		free(label);
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml,"yes_no_dialog_label")), l);
		free(l);
		gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "yes_no_dialog")));
		if(res == GTK_RESPONSE_YES){
			gtk_widget_hide(glade_xml_get_widget(xml, "yes_no_dialog"));
		}
		else{
			gtk_widget_hide(glade_xml_get_widget(xml, "yes_no_dialog"));	
			return;
		}
		
		// make sql
		gchar * sql = NULL;
		sql = append_string(sql, "DELETE FROM \"");
  	sql = append_string(sql, schema);
  	sql = append_string(sql, "\".\"");
  	sql = append_string(sql, table);
  	sql = append_string(sql, "\"\n  WHERE ");
  	
  	if(list != NULL){
  		int i = 0;
  		for( i = 1, list = list->next; list != NULL; list = list->next, i++){
  				GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
					gchar * name = copy_string(gtk_tree_view_column_get_title(col));
					sql = append_string(sql, "\"");
					sql = append_string(sql, name);
					sql = append_string(sql, "\" = ");
					
					gchar *value = NULL;
					gtk_tree_model_get(model, &iter, i, &value, -1);
					gchar * v = get_text_from_markup(value);
					free(value);
					sql = append_string(sql, "\'");
					sql = append_string(sql, v);
					sql = append_string(sql, "\'");
					free(v);
					if(list->next != NULL) sql = append_string(sql, " AND ");
  		}
  	 	
  	 	sql = append_string(sql, ";\n");
  			
  		// execute SQL query
    	if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
  				fetch_records(user_data);
  			}
  		g_list_free(list);		
  	}
  	free(sql); 
  	free(schema);
  	free(table);
  }
} // on_data_delete_clicked()

/*
 * Function for data edit
 */
void
on_data_edit_clicked(GtkButton *button, gpointer user_data){
	init_op_dialog();
	
	gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "label203")), "<span font_desc='9 Bold' foreground='#FFFFFF'>Data</span>");
	
	gtk_widget_set_sensitive(glade_xml_get_widget(xml, "opd_ok"), TRUE);
	
	GtkWidget * dialog = glade_xml_get_widget(xml, "object_properties_dialog");
	// set title
	gtk_window_set_title(GTK_WINDOW(dialog), "Table edit data");
	
	// add properties
	GtkWidget * properties_columns = glade_xml_get_widget(xml, "opd_properties");
  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_set_name(properties_column1, "properties_column1");
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_set_name(properties_column2, "properties_column2");
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);
  
  // get table name
  T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		gchar * table = NULL;
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_table_name");
		if(wid != NULL) table = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
		else return;
		
		gchar * schema = NULL;
		wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_schema_name");
		if(wid != NULL) schema = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
		else return;
		
		// get profile		
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Profile * profile = NULL;
		if(depth >=3 ){
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		
  	// get columns
  	wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "data_view");
		if(wid == NULL) return;
		
		GList * list = NULL, *pom_list = NULL, *value_list = NULL;
  	list = gtk_tree_view_get_columns(GTK_TREE_VIEW(wid));
  	if(list == NULL) return;
  	
  	// get selected row
		GtkTreeSelection * selection;
		GtkTreeView * view = GTK_TREE_VIEW(wid);
		GtkTreeModel * model = gtk_tree_view_get_model(view);
		GtkTreeIter iter;
		selection = gtk_tree_view_get_selection(view);
		if(!gtk_tree_selection_get_selected(selection, &model, &iter)) return;
		
  	// add entries
 	 	gint height = 0;
		add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), table,  PIXMAP_DIRECTORY "/Table.png");
		height += 21;
		gint i = 1;
		for(list = list->next; list != NULL; list = list->next, i++){
			GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
			pom_list = g_list_append(pom_list, col);
			gchar * name = copy_string(gtk_tree_view_column_get_title(col));
			gchar * value = NULL;
			gtk_tree_model_get(model, &iter, i, &value, -1);
			gchar * v = get_text_from_markup(value);
			free(value);
			add_entry_property(name, dialog, GTK_BOX(properties_column1), GTK_BOX(properties_column2), name, v);
			value_list = g_list_append(value_list, copy_string(v));
			free(v);
			free(name);
			height += 21;	
		}
		gtk_widget_set_size_request (glade_xml_get_widget(xml, "scrolledwindow11"), -1, height);
		
		
		// run dialog
  	gboolean end = FALSE;
  	do{
  		end = FALSE;
  	gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "object_properties_dialog")));
  	if(res == GTK_RESPONSE_OK){
  		gchar * sql = NULL;
  		
  		// get values from dialog
  		sql = append_string(sql, "UPDATE \"");
  		sql = append_string(sql, schema);
  		sql = append_string(sql, "\".\"");
  		sql = append_string(sql, table);
  		sql = append_string(sql, "\" SET ");
  		list = pom_list;
  		if(list != NULL && value_list != NULL){
  			for(; list != NULL; list = list->next){
  				GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
					gchar * name = copy_string(gtk_tree_view_column_get_title(col));
					sql = append_string(sql, "\"");
					sql = append_string(sql, name);
					sql = append_string(sql, "\" = ");
					wid = NULL;
					wid = get_widget_child_by_name(dialog, name);
					gchar * value = NULL;
					if(wid != NULL) value = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
					else value = copy_string("");
					sql = append_string(sql, "\'");
					sql = append_string(sql, value);
					sql = append_string(sql, "\'");
					free(value);
					if(list->next != NULL) sql = append_string(sql, ", ");
  			}  			
  			sql = append_string(sql, " WHERE ");
  			
  			list = pom_list;
  			for(; list != NULL; list = list->next, value_list = value_list->next){
  				GtkTreeViewColumn * col = (GtkTreeViewColumn *) list->data;
					gchar * name = copy_string(gtk_tree_view_column_get_title(col));
					sql = append_string(sql, "\"");
					sql = append_string(sql, name);
					sql = append_string(sql, "\" = ");
					sql = append_string(sql, "\'");
					sql = append_string(sql, (gchar*) value_list->data);
					sql = append_string(sql, "\'");
					if(list->next != NULL) sql = append_string(sql, " AND ");
  			}
  			sql = append_string(sql, ";\n");
  			
  			// execute SQL query
  			if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
  				on_last_clicked(NULL, user_data);
  				end = TRUE;
  			}
  			
  			free(sql);
  		}
  	}
  	else end = TRUE;
  	}while(!end);
  	gtk_widget_hide(glade_xml_get_widget(xml, "object_properties_dialog"));
  	free(table);
  	free(schema);
  	g_list_free(list);
  	g_list_free(pom_list);
  	g_list_free(value_list);
	}
	gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "label203")), "<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
} // on_data_edit_clicked ()

/*
 * First data page
 */
void
on_first_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
	
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Table * table;
		if(depth >= 7){
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		}
		else return;
		// update rows
		if(table->data.limit == 0) table->data.offset = 0;
		else{
			table->data.offset = 0;
		}
	}
	fetch_records(user_data);
} // on_first_clicked

/*
 * Previous data page
 */
void
on_previous_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
	
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Table * table;
		if(depth >= 7){
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		}
		else return;
		// update rows
		if(table->data.limit == 0) table->data.offset = 0;
		else{
			if(table->data.offset != 0){
				table->data.offset = table->data.offset - table->data.limit;
				if(table->data.offset < 0) table->data.offset = 0;
			}
		}
	}
	fetch_records(user_data);
} // on_previous_clicked ()

/*
 * Next data page
 */
void
on_next_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
	
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Table * table;
		T_Schema * schema;
		T_Profile * profile;
		
		if(depth >= 7){
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		  schema = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]];
		  profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else return;
				
		if(table->data.limit == 0) table->data.offset = 0;
		else { 
			// update rows
			table->data.rows = get_ntuples(table, schema, profile);
			if(table->data.offset+table->data.limit <= (table->data.rows-1)) table->data.offset = table->data.offset + table->data.limit;
		}
		fetch_records(user_data);
	}
} // on_next_clicked ()

/*
 * Last data page
 */
void
on_last_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
	
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Table * table;
		T_Schema * schema;
		T_Profile * profile;
		
		if(depth >= 7){
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		  schema = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]];
		  profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else return;
		
		
		if(table->data.limit == 0) table->data.offset = 0; // show data with no limit
		else{
			// update rows
			table->data.rows = get_ntuples(table, schema, profile);
			gint diff = table->data.rows % table->data.limit;
			if(diff == 0) diff = table->data.limit;
			table->data.offset = table->data.rows - diff;
		}
		fetch_records(user_data);
	}
} // on_last_clicked ()

/*
 * Number records limit per data page
 */ 
void
on_limit_changed (GtkEditable *editable, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		GtkWidget * wid = NULL;
		// clear treeview
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "limit_count");
		if(wid == NULL) return;
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Table * table;
		if(depth >= 7){
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		}
		else return;
		// update rows
		table->data.limit = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(wid));
	}
	fetch_records(user_data);	
} // on_limit_changed ()

/*
 * Fetch all records
 */
void
on_fetch_all_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Profile * profile;
		T_Schema * schema;
		T_Table * table;
		if(depth >= 7){
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
			schema = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]];
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		  if(table->data.condition != NULL){
		   	free(table->data.condition);
		   	table->data.condition = NULL;
		  }
		}
		else return;
		table->data.rows = get_ntuples(table, schema, profile);
		table->data.offset = 0;
	}
	fetch_records(user_data);
} // on_fetch_all_clicked ()

/*
 * Fetch filtered records
 */
void
on_fetch_filtered_clicked(GtkButton *button, gpointer user_data){
	GtkTextBuffer * buffer;
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (glade_xml_get_widget(xml, "filter_text_view")));
	GtkTextIter start, end;
  gtk_text_buffer_get_start_iter(buffer, &start);
  gtk_text_buffer_get_end_iter(buffer, &end);
  gtk_text_buffer_delete(buffer, &start, &end);
	init_text_view(glade_xml_get_widget(xml, "filter_text_view"), TRUE, "");

	gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "filter_data_dialog")));
	if(res == GTK_RESPONSE_OK){ // show data
	  gtk_widget_hide(glade_xml_get_widget(xml, "filter_data_dialog"));
	}	
	else{ // Cancel
	  gtk_widget_hide(glade_xml_get_widget(xml, "filter_data_dialog"));
	  return;
	}


  gtk_text_buffer_get_start_iter(buffer, &start);
  gtk_text_buffer_get_end_iter(buffer, &end);
  gchar * filter_string = gtk_text_buffer_get_text(buffer, &start, &end, TRUE);
	

	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		// get properties
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Profile * profile;
		T_Schema * schema;
		T_Table * table;
		if(depth >= 7){
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
			schema = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]];
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		}
		else return;
		// update rows
		if(table->data.condition != NULL) free(table->data.condition);
		table->data.condition = copy_string(filter_string);
		table->data.rows = get_ntuples(table, schema, profile);
		table->data.offset = 0;
	}
	fetch_records(user_data);
} // on_fetch_filtered_clicked ()

/*
 * Fetch records
 */
void
fetch_records(gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		// get properties
		GtkWidget * wid = NULL;
		// clear treeview
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "data_view");
		if(wid == NULL) return;
		GtkTreeModel * model = gtk_tree_view_get_model(GTK_TREE_VIEW (wid));
		if(model != NULL){
			gtk_list_store_clear(GTK_LIST_STORE(model));
			GList * list = gtk_tree_view_get_columns(GTK_TREE_VIEW (wid));
			for(; list != NULL; list = list->next) gtk_tree_view_remove_column(GTK_TREE_VIEW (wid), GTK_TREE_VIEW_COLUMN(list->data));
		}
		
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		gchar * schema;
		T_Profile * profile;
		T_Table * table;
		if(depth >= 7){
		  profile = o_tree.server[intpath[0]]->profile[intpath[2]];
			schema = copy_string(o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name);
		  table = o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->table[intpath[6]];
		}
		else return;
		
		gchar * sql = append_string(NULL, "SELECT * FROM \"");
		sql = append_string(sql, schema);
		sql = append_string(sql, "\".\"");
		sql = append_string(sql, table->name);
		sql = append_string(sql, "\"");
		if(table->data.condition != NULL){
			sql = append_string(sql, " WHERE ");
			sql = append_string(sql, table->data.condition);
		}
		if(table->data.limit != 0){
			sql = append_string(sql, " LIMIT ");
			gchar * limit = itoa_n( table->data.limit, 0);
			sql = append_string(sql, limit);
			free(limit);
			sql = append_string(sql, " OFFSET ");
			gchar * offset = itoa_n( table->data.offset, 0);
			sql = append_string(sql, offset);	
			free(offset);
		}
		sql = append_string(sql, ";");
		
		execute_sql(sql, GTK_TREE_VIEW(wid), NULL, profile, TRUE, FALSE);
		
		free(schema);
		free(sql);
	}
} // fetch_records ()
